						 -*- coding: utf-8 -*-
BRL-CAD Release Notes
=====================

This document provides a transcript of release notes and user-visible
changes for each release of BRL-CAD.  The individual changes are
listed in chronological order with the most recent changes listed
first and are grouped by release.  Each release also includes optional
descriptive text that emphasizes or further describes significant
changes made.  See document footer for additional details.

----------------------------------------------------------------------
--- 2013-06-02  Release 7.24.2                                     ---
----------------------------------------------------------------------

This patch release includes a plethora of significant bug fixes and
improvements to BRL-CAD including fixing ADRT/TIE fast triangle ray
tracing on 32-bit platforms, fixing an issue in our FASTGEN converter
that affected the import of very complex geometry models, upgrading
one of our third-party dependencies (libpng) in response to a
vulnerability report, and improving the 'comb' and 'search' commands
with new options for restructuring and searching geometry.
Enhancements continue to be made to our boundary representation (BREP)
NURBS infrastructure in support of hybrid representation modeling and
improved geometry interchange with other CAD systems.

* improved rcodes output to inform user what changed - Cliff Yapp
* fixed inside command for ellipsoid primitives - Cliff Yapp
* restored suppressed mged output after some commands - Cliff Yapp
* added rtwizard -s square image size option - Cliff Yapp
* documented image size options in rtwizard man page - Cliff Yapp
* added view center specification dialog to rtwizard - Cliff Yapp
* increased rtwizard window size for button visibility - Cliff Yapp
* image conversion -R/-G/-B options now require weight - Mohit Daga
* improved option consistency for image processing tools - Mohit Daga
* improved pipe ray tracing grazing hit behavior - Keith Bowman
* upgraded libpng, now at version 1.6.10 - Erik Greenwald, Cliff Yapp
* improved solid NURBS geometry ray tracing behavior - Keith Bowman
* fix z-clipping bug in MGED's X display manager - Cliff Yapp
* added attribute sorting option to the 'attr' command - Tom Browder
* changed 'bwfilter' tool offset option from -o to -O - Mohit Daga
* gattributes section 5 man page renamed to attributes - Tom Browder
* changed 'benchmark' defaults: 2% deviation, 5 frames - Sean Morrison
* improved bwrect to handle redirected input and output - Mohit Daga
* upgraded boost to version 1.55.0 - Tom Browder
* fixed TIE mesh raytrace crashes on 32-bit platforms - Sean Morrison
* fixed pixscale and bwscale to not output ioctl error - Mohit Daga
* improved fast4-g import of numerous region groups - Richard Weiss
* fixed archer hidden line edit getting redrawn as shaded - Nick Reed
* fixed adrt/TIE polygonal mesh memory management bug - Richard Weiss
* fixed fast4-g importer parsing of blank input lines - Richard Weiss
* added -o flag to 'bb' command for oriented bounding box - Cliff Yapp
* allow search to see hidden combs with the -a flag - Cliff Yapp
* added comb -l lift option to change region designation - Cliff Yapp
* improved NURBS ray tracing grazing hit behavior - Keith Bowman
* print current grid information in gqa output - Cliff Yapp
* added -f option for flattening combs to 'comb' command - Cliff Yapp
* added support for boolean op filtering in search - Cliff Yapp
* added new g-raw geometry converter - Jon Engbert, Daniel Roßberg
* improved g-stl usage and documentation - Jon Engbert
* added -c and -r region flag options to the comb command - Cliff Yapp
* added -p/-P point/line plot options to 'burst' tool - Sean Morrison
* added -w wrapping option to the 'comb' command - Cliff Yapp
* archer respects LIBRT_BOT_MINTIE environment variable - Bob Parker
* new 'cchannel' procedural geometry tool for C-Channel - Emory Huff
* improved 'comb' command error messages - Talwinder Saini
* pl -> plot3 rename for utilities and docs - Tom Browder, Cliff Yapp
* exposed 'coil' command within mged & archer - Alexandrus, Cliff Yapp
* added centroid reporting to 'analyze' command output - Csaba Nagy
* added arb8 centroid 'analyze' command reporting - Silviu Ungureanu
* pipe centroid, volume, & surface area analyze reporting - Csaba Nagy
* added ebm centroid 'analyze' command reporting - Michael Huang
* improved help option consistency across numerous tools - Carl Moore


----------------------------------------------------------------------
--- 2013-06-13  Release 7.24.0                                     ---
----------------------------------------------------------------------

This major update to BRL-CAD comes after nearly a full year of
development.  This is the alpha release unveiling of Archer/MGED, a
preliminary interface update to BRL-CAD's graphical geometry editor.
As alpha software, this new MGED prototype aims to provide functional
feature parity with the antecedent MGED interface while introducing
various changes.  Included is an integrated graphical tree view, a
single window framework, drag-and-drop geometry editing, information
panels, shortcut buttons, improved polygonal mesh and 2D sketch
editing, level-of-detail wireframes, NURBS shaded display support, and
much more.  Prior to upcoming beta testing where the emphasis will
predominantly be on stability and usability, this alpha status
solicits feedback from the community on capability and features.

This release also includes various improvements to BRL-CAD's ray
tracing infrastructure including CPU thread affinity locking for
faster performance, more consistent grazing hit behavior, expanded
volume and surface area calculations, numerous bug fixes, and more
robust NURBS evaluation.  Following BRL-CAD's interface deprecation
policy (see CHANGES file), the Jove text editor is no longer being
bundled.  Numerous converters receive robustness improvements
including the STEP, Patch, and 3DM importers.

* improved gqa performance on parallel SMP hardware - Richard Weiss
* fixed bounding box size calculation for pipe geometry - Bob Parker
* improved help option consistency across numerous tools - Carl Moore
* 'idents' command no longer reports negative booleans - Keith Bowman
* improved support for NURBS with big uv-domain changes - Keith Bowman
* improved ray tracing behavior for grazing rays - Keith Bowman
* improved robustness of the step-g geometry importer - Nick Reed
* fixed search command bombing on v4 database file - Sean Morrison
* fixed graphics window z-clipping bug in mged - Bob Parker
* fixed mged lesson 15 toy truck 'inside' ordering bug - Sean Morrison
* fixed uninstallable Linux RPM package on Fedora 18 - Jordi Sayol
* improved Mac, BSD, & Windows ray tracing performance - Sean Morrison
* improved Linux ray tracing via cpu thread affinity - Akshay Kashyap
* fixed nirt high object count failure on Windows - Richard Weiss
* added plate mode BoT support to 'bot_merge' command - Richard Weiss
* jove removed, see jove.emacs for compatibility bindings - Cliff Yapp
* added gqa -q quiet option to suppress 'was not hit' - Richard Weiss
* level-of-detail mged configuration dialog, under Tools - Nick Reed
* added level-of-detail wireframe support to mged/archer - Nick Reed
* initial NURBS shaded display and tessellation support - Keith Bowman
* fixed patch-g -f input file permissions failure - Sean Morrison
* improved large file support for the patch-g importer - Sean Morrison
* upgraded libpng to version 1.5.12 - Cliff Yapp
* openNURBS updated to version 5.0 (2012-10-24) - Richard Weiss
* improved BoT mesh editing interface in archer - Bob Parker
* fixed crash when running screengrab in archer - Nick Reed
* fixed memory leak when working with pipe primitives - Daniel Roßberg
* fixed asc2g and mged empty revolve object crashes - Sean Morrison
* improved Linux support for multiple hardware displays - Bob Parker
* fixed crash when parsing invalid shader parameters - Cliff Yapp
* fixed mged 'dbupgrade' -permissions error on windows - Sean Morrison
* fixed infinite loop raytracing subtracted lights - Sean Morrison
* added hyp centroid and volume output to 'analyze' - Aaron Keesing
* added support for wireframe drawing of 'hyp' labels - Bob Parker
* fixed random number SMP bug affecting rt and adrt - Sean Morrison
* added support for editing 2D sketch objects in archer - Bob Parker
* fixed File->New deprecation error in archer - Sean Morrison
* improved Linux platform application and file icons - Jordi Sayol
* modified gqa to report all missed regions - Richard Weiss
* added epa surface area and volume to analyze command - Chris Dueck
* added arbn surface area and volume to analyze command  - Chris Dueck
* added eto surface area and volume to analyze command  - Chris Dueck
* quell pix-png gAMA chunk warning defaulting to unset - Sean Morrison
* fixed mged interactive object translation keypoint bug - Bob Parker
* fixed corrupted tessellation pipe export bug - Richard Weiss
* fixed memory leak in bot_condense - Chris Dueck
* output from g-var no longer prints 'fwrite' messages - Sean Morrison
* fixed gqa to not report overlap regions as zero hits - Richard Weiss
* fixed crash in step-g tool importing AP214 entities - Sean Morrison
* improved 3dm-g output and invalid geometry support - Sean Morrison
* fixed crash revolving empty sketch objects - Sean Morrison
* fixed TIE raytracing bugs shotlining plate-mode BoTs - Sean Morrison
* g_diff gives non-zero return code if .g files differ - Sean Morrison
* fixed typographical errors in numerous tools and docs - Carl Moore
* fixed TIE perpendicular face mesh evaluation failure - Richard Weiss
* added -b option to set tpkg network packet size - Andrei Popescu
* added manual page for existing mged reid command - Richard Weiss
* added manual page for bot_sync, bot_flip, bot_split - Richard Weiss
* added manual page for running rtarea within mged - Richard Weiss
* improved documentation consistency and authorship info - Tom Browder
* new mouse-input unpushed matrix edit option in archer - Bob Parker
* fixed bug during pipe editing with working units set - Bob Parker


----------------------------------------------------------------------
--- 2012-06-25  Release 7.22.0                                     ---
----------------------------------------------------------------------

After many months of development, this release includes hundreds of
fixes for source code defects, logic and memory management bugs,
potential security vulnerabilities, and numerous other issues reported
by Coverity Static Analysis.  While having participated in the
Coverity Scan Initiative since inception in 2006, this release marks a
completion milestone with the review and resolution of all reported
issues, more than 2100 overall.  Every defect was inspected, code
modifications were peer-reviewed, critical features were tested, and
user-visible changes were documented.  Along with other on-going
improvement efforts such as treating all compiler-generated warnings
as errors, time and attention continues to be put forth towards
improving BRL-CAD's maintainability and source code quality.

Development of BREP/NURBS representation support within BRL-CAD
continues to mature with this release including ray tracing
improvements, tighter bounding boxes for better performance, progress
converting from traditional implicit+CSG representations to NURBS+CSG,
wireframe improvements, and a thorough verification and validation
(V&V) review for analysis suitability.  The V&V review compared
BRL-CAD's primitives in implicit, polygonal mesh, and NURBS form
evaluating more than a dozen separate tests looking for differences in
rendering, curvature, presented areas, volume, and more.  The review
identified a couple minor issues that were inspected and fixed but
successfully demonstrated the viability of using our BREP/NURBS
implementation for geometric representation and analysis purposes.

This release introduces numerous major feature developments including
the initial implementation of a new physics simulation capability, a
new ambient occlusion rendering mode, and the integration of rtwizard
into Archer.  The simulation system was developed by Abhijit Nandy
under the European Space Agency's 2011 Summer of Code in Space (SOCIS)
program; and it allows BRL-CAD geometry objects to dynamically
interact with each other (e.g., collision detection, friction) or with
the environment (e.g., gravity).  Ambient occlusion is a shading
method that helps add considerable realism and feature definition to
renderings, enabled within rt using the "set ambSamples=128" command.
The rtwizard rendering interface was extended to work as a
command-line tool (useful for scripting) and was integrated within
Archer as the underlying rendering interface.

Conversion support continues to be a development priority with
significant importer enhancements for the STEP, OBJ, COMGEOM, FASTGEN,
and RAW file formats.  The STEP importer in particular receives
several updates, support for importing assembly hierarchies, and is in
the process of being fully ported to Windows.  This release also fixes
more than 40 user-visible bugs including a significant database
corruption issue.  A database corruption issue was discovered and
fixed affecting 64-bit big endian platforms (e.g., IBM Power Series
supercomputers) when writing out ebm, dsp, vol, and hf primitives.

BRL-CAD's documentation continues to be extended, improved, and
translated due to the sustained efforts of several contributors.
Manual page documentation is now available on Windows through the
'brlman' command and within MGED.  Several utilities and commands that
previously had no documentation now have manual pages; many others
received corrections and improvements.  The introductory article
"About BRL-CAD" is now available in Russian, Italian, and Armenian.

* numerous manual page corrections and improvements - Tom Browder
* integration of rtwizard traits into archer - Bob Parker, Cliff Yapp
* new asc2dsp prep tool for displacement map data files - Tom Browder
* fixed a problem with rt writing pix files on Windows - Bob Parker
* added new raw-g raw triangle mesh to BoT importer - Daniel Roßberg
* added Windows man page support (using html) to brlman - Cliff Yapp
* added support for section numbers to brlman script - Cliff Yapp
* new manual pages for asc2dsp, dsp, asc2pix, and asc2g - Tom Browder
* fixed bug creating binary uniform (binunif) objects - Sean Morrison
* fixed memory corruption bug reading v4 geometry - Sean Morrison
* fixed bug where small raytraces were being rotated - Erik Greenwald
* ios-icon.sh script added for generating IOS icons - Erik Greenwald
* support for implicit to boundary representation geometry conversion
	- Cliff Yapp, Wu Jianbang, Sean Morrison
* added rtwizard support for writing out .png images
	- Bob Parker, Cliff Yapp, Richard Weiss
* fixed region demotion bug in the mged 'red' command - Richard Weiss
* added implicit conversion support to 'brep' command - Wu Jianbang
* improved NURBS raytracing grazing hit & edge behavior - Keith Bowman
* added initial documentation for make_pnts command - Richard Weiss
* fixed gqa crash when specified objects didn't exist - Richard Weiss
* rtedge and rtwizard support multiple occlusion objects - Bob Parker
* fixed mged matrix edit bug selecting the last matrix - Bob Parker
* added 'lc' command to mged for listing region codes - Richard Weiss
* fixed rtedge/rtwizard edge overlay rendering bug - Bob Parker
* fixed 'open: Permission denied' rtedge output file bug - Cliff Yapp
* upgraded libpng to 1.5.10 - Cliff Yapp
* fixed various memory leaks in the comgeom-g geometry importer
	- Tom Browder, Nick Reed
* fixed comgeom-g bug importing ars primitive objects - Tom Browder
* added new command-line invocation support to rtwizard - Cliff Yapp
* fixed BoT mesh hit offset and vanish TIE render bugs - Keith Bowman
* improved nurbs raytracing when shooting from inside - Keith Bowman
* added 'draw'/'e' -m1 option for shading BoTs in mged - Richard Weiss
* expanded docs on mged listeval and 'l' list commands - Richard Weiss
* removed obsolete 'syn' multi sine synthesis tool - Sean Morrison
* fixed memory corruption in vegetation generator tool - Sean Morrison
* fixed ARS bounding box size affecting overlap handling - Cliff Yapp
* fixed bug in fast4-g importer handling HOLE/WALL cards - Nick Reed
* fixed field truncation bug in comgeom-g importer - Tom Browder
* fixed log file clobber bug in the benchmark suite - Cliff Yapp
* enabled new 'select' command for use within mged - Richard Weiss
* added preliminary object 'select' command to archer - Bob Parker
* improved support for the Intel C/C++ compiler (icc) - Sean Morrison
* now sorting top level object alphabetically in rtwizard - Cliff Yapp
* "About BRL-CAD" article translation to Russian - Ilya
* "About BRL-CAD" article translation to Armenian - Karen Mgebrova
* "About BRL-CAD" article translation to Italian
	- Unknown Contributor, Tom Browder
* improved handling of rgb/color attributes by adjust cmd - Cliff Yapp
* added initial support for step-g import of assemblies - Keith Bowman
* added a basic SWIG spec file - Erik Greenwald
* fixed referenced object highlighting in archer treeview - Bob Parker
* fixed error handling input reading failure in burst - Sean Morrison
* fixed memory double-freeing issue in shp-g - Erik Greenwald
* added optional scaling parameter to autoview command - Sean Morrison
* fixed extrude object bug rendering at near right angles - Bob Parker
* added -h option to nirt to suppress header printing - Cliff Yapp
* fixed nirt attribute reporting for specified attributes - Cliff Yapp
* fixed ebm/dsp/vol/hf corruption on 64-bit big endian - Sean Morrison
* fixed step-g importer memory management issues - Keith Bowman
* improved tab-completion behavior for mged and archer - Sean Morrison
* fixed pervasive string handling memory leak - Tom Browder
* improved table output formatting for 'analyze' command - Tom Browder
* improved rtweight portability and density file parsing - Tom Browder
* fixed crash in anim_cascade animation tool - Nick Reed
* fixed bug in gif2fb processing non-interlaced images - Sean Morrison
* fixed crash in coil when using -S and -l options - Cliff Yapp
* fixed mged 'make_pnts' command resource contention bug - Nick Reed
* fixed nirt memory leak and scriptfile off-by-one bug - Sean Morrison
* d2-c now handles the imaginary part correctly - Erik Greenwald
* fixed raytracer crash if output file creation fails - Erik Greenwald
* restored mged BoT editing interface functionality - Tom Browder
* fixed mged 'solids' and 'regions' command crashes - Tom Browder
* fixed orientation bug in mged 'ypr' rotation command - Nick Reed
* fixed mged bug setting color via Combination Editor - Nicholas Reed
* fixed numerous xyz/ypr orientation bugs in anim tools - Nick Reed
* improved tessellation of pipe bends for conversion - Richard Weiss
* fixed keypoint vertex bug when editing extrude objects - Nick Reed
* fixed eto error converting hyp objects with asc2g tool - Nick Reed
# fixed mged bug processing edcodes command arguments - Bob Parker
* various improvements to NMG polygonal mesh processing robustness
	- Nick Reed, Sean Morrison, Richard Weiss
* improved bad face handling within the obj-g importer - Nick Reed
* fixed crash during rt -c "ae 35 25" view change - Bob Parker
* added -r BoT orientation option on the obj-g importer - Nick Reed
* added ambient occlusion shading method to rt - Lee Butler
* fixed attribute handling bug affecting v4 geometry - Daniel Roßberg
* reid command now reports the highest region ID set - Carl Moore
* batch script shortcuts now set PATH on Windows - Sean Morrison
* fixed g-obj error when exporting facets - Christopher Pitts
* added 'l' list command to archer so 'g' expands args - Bob Parker
* added length parameter documentation for 'coil' command - Cliff Yapp
* improved performance of boolean evaluations - Richard Weiss
* added support for braces around shader parameters - Nick Reed
* improved boolean evaluation converting to polygons - Richard Weiss
* ported the obj-g geometry importer to Windows - Nicholas Reed
* improved import robustness and parsing of OBJ geometry files
	- Nicholas Reed, Richard Weiss, Mike Tegtmeyer
* added new physics 'simulate' command to mged/archer - Abhijit Nandy
* improved archer bot selection utility with sorted names - Bob Parker
* added 'bb' bounding box command usage within mged - Tom Browder


----------------------------------------------------------------------
--- 2011-10-30  Release 7.20.4                                     ---
----------------------------------------------------------------------

* added lighting model visualization options for archer - Bob Parker
* reid command now takes optional -n "incr by" value - Erik Greenwald
* reid command now returns the last region ID set - Erik Greenwald
* improved nirt support for non-UNIX-style text files - Sean Morrison
* added new relos thickness reassignment command to mged - Carl Moore
* support for loading archer plugins with spaces in name - Bob Parker
* added 'exists' object detection command to mged/archer - Cliff Yapp
* added archer BoT split/flip/sync surface cleanup panel - Bob Parker
* added new g-dot exporter for hierarchy visualization - Sean Morrison
* improved g-vrml successful exporting and reporting - Richard Weiss
* added -b BoT dump and -e evaluation option to g-vrml - Richard Weiss
* improved obj-g polygonal import - Nicholas Reed, Richard Weiss
* fixed mged crash after killing an illuminated object - Abhijit Nandy
* tightened default polygonal mesh export tolerance - Sean Morrison
* converted introductory Tcl/Tk presentation to Docbook - Tom Browder
* initial support in archer for editing pipe primitives - Bob Parker
* fixed NURBS raytracing crash due to invalid geometry - Sean Morrison
* fixed memory leak when saving BoT geometry - Nicholas Reed
* improved mged object name globbing support - Sean Morrison
* improved bounding box for rpc, epa, ehy, hyp primitives - Cliff Yapp
* improved handling of degenerate face facetization - Richard Weiss
* add support for .png file output in rtwizard - Cliff Yapp
* improved rtwizard's invocation of rt - Cliff Yapp
* added object path and keep options to conversion.sh - Tom Browder
* 'keep' command includes sketch when keeping revolve - Sean Morrison
* fixed mged 'mater' command inheritance setting bug - Richard Weiss
* fixed mged crash removing comb members during edit - Richard Weiss
* modified archer startup to not require html documentation files
	- Cliff Yapp, Brandon Hinesley
* improved mged/archer/bwish run-time path behavior on Windows
	- Cliff Yapp, Bob Parker
* upgraded libpng to version 1.5.4 - Cliff Yapp
* improved performance of step-g importer - Zach Easterbrook
* fixed browsing mged html help pages on Windows - Bob Parker
* restored mged 'rt' command output to console window - Sean Morrison
* fixed infinite loop bug plotting NURBS wireframes - Sean Morrison
* added new 'ringworld' procedural geometry generator - Erik Greenwald
* fixed mged Manual page item in help menu - Brandon Hinesley


----------------------------------------------------------------------
--- 2011-07-01  Release 7.20.2                                     ---
----------------------------------------------------------------------

* improved fusing of coplanar faces (tessellation) - Richard Weiss
* fixed rtwizard issues with unknown units and freezing - Bob Parker
* fixed problem with mater command setting color - Cliff Yapp
* fixed crash rendering scenes with all invalid lights - Sean Morrison
* improved reliability of ARS tessellation/conversion - Richard Weiss
* improved tessellation performance and reliability - Richard Weiss
* replaced 'erase_all' command with 'erase -r' - Brandon Hinesley
* improved 'ls' command error reporting in archer - Brandon Hinesley
* fixed related object highlighting in archer's tree view - Cliff Yapp
* added closedb command to archer - Brandon Hinesley
* improved behavior of opendb command in archer - Brandon Hinesley
* improved archer/mged manual page browser behavior - Brandon Hinesley
* added man documentation command to archer - Brandon Hinesley
* improved File->New dialog in mged - Brandon Hinesley
* all cmake files now included in dist - Erik Greenwald, Sean Morrison


----------------------------------------------------------------------
--- 2011-05-27  Release 7.20.0                                     ---
----------------------------------------------------------------------

This release marks the introduction of a new CMake build system for
BRL-CAD.  CMake is cross-platform build system infrastructure capable
of generating native build system logic for a wide variety of
operating systems and compilation environments.  Cliff Yapp has been
diligently working on this adaptation for a number of months in order
to simplify the task of maintaining BRL-CAD on multiple platforms.

Previously, two separate build systems were being maintained: one
system (GNU Autotools) for Linux, UNIX, and BSD platforms (including
Mac OS X); and another separate system (Microsoft Visual Studio) for
Windows.  The new build system supports all platforms (including
Windows) from the same build logic.  This eliminates the need to
manually update multiple build systems and improves BRL-CAD
cross-platform maintainability.

* fixed mged/archer graphics window glitches on Windows - Bob Parker
* improved 'attr' command to work with read-only .g files - Cliff Yapp
* cross-platform 64-bit ISST (cmake-only) - Cliff Yapp, Erik Greenwald
* fixed mged zoom out mouse binding on Linux/*BSD - Cliff Yapp
* fixed step-g importer bug interpolating cubic curves - Keith Bowman
* improved step-g importer ellipse and conic support - Keith Bowman
* improved multiple path handling for search command - Cliff Yapp
* fixed segment splitting tessellation conversion bug - Richard Weiss
* fixed crash during facetization of large models - Richard Weiss
* fixed asc2g bug importing color and other attributes - Bob Parker
* added -q "quiet lookup" option to the 'ls' command - Cliff Yapp
* fixed numerous 'red' command text edit bugs and robustness issues
	- Cliff Yapp, Sean Morrison
* modification of LIBRT spatial partition traversal ordering
	- Sean Morrison, Keith Bowman
* new LIBRT_BOT_MINTIE environment variable override - Erik Greenwald
* changed search output order to shallow followed by deep - Cliff Yapp
* added search support for '.' object list search results - Cliff Yapp
* red -f flag to force overwriting pre-existing combs - Sean Morrison


----------------------------------------------------------------------
--- 2011-04-12  Release 7.18.4                                     ---
----------------------------------------------------------------------

After considerable development, this release includes the preliminary
integration of our high-performance Triangle Intersection Engine (TIE)
with BRL-CAD's LIBRT raytrace library.  TIE uses specialized
acceleration techniques for faster raytracing of triangle mesh models.
TIE was experimentally developed over several years as part of
BRL-CAD's Advanced Distributed Ray Tracer (ADRT) tool suite.  As this
is the initial integration, TIE is available but presently disabled by
default.  The engine optimization is configurably integrated with
LIBRT mesh (BoT) raytracing and optionally enabled via settings
available in RT and MGED.  Initial testing of "real-world" models shows
average improvements around 20-60% while individual meshes with high
(1M+) face counts are rendering more than 2000% faster than before.

Also included in this release is the development of a new "shp-g"
geometry importer for Shapefile data.  Shapefiles are a common file
format for storing geospatial vector data commonly used by geographic
information systems (GIS) software.  Shapefiles may be imported as 2D
sketch geometry that can be extruded to a 3D representation.

* fixed units conversion bug with mged 'title' command - Bob Parker
* fixed memory management crash in the dem-g importer - Richard Weiss
* fixed edcolors so it retains and accepts colors again  - Cliff Yapp
* support for applying matrix edits to revolve primitives - Dongxu Li
* fixed mged 'red' command bug on Windows - Sean Morrison, Cliff Yapp
* support matrices over halfspaces within combinations - Sean Morrison
* fixed archer and rtwizard startup failure bug on Mac - Sean Morrison
* fixed bug starting up the Combination Editor in mged - Sean Morrison
* mged 'mater' command interactive prompting restored - Sean Morrison
* added pix2fb and fb2pix screenshot commands to archer - Bob Parker
* fixed bug running nirt on a Windows command terminal - Bob Parker
* improved wireframe updating when editing within mged - Sean Morrison
* added -T bot_mintie BoT optimization options to nirt - Sean Morrison
* fixed Windows display manager bug when drawing strings - Bob Parker
* mged command-click zoom binding for one button mice - Sean Morrison
* removed 'txyz-pl' utility tool in favor of 'xyz-pl' - Sean Morrison
* new shp-g importer for Esri Shapefile geometry files - Sean Morrison
* new 'rt_bot_mintie' option for triggering TIE BoTs  - Erik Greenwald
* integrated optimized TIE BoT raytracing with LIBRT - Erik Greenwald


----------------------------------------------------------------------
--- 2011-02-09  Release 7.18.2                                     ---
----------------------------------------------------------------------

This release provides initial support for reading some older
(platform-dependent) v4 geometry database files regardless of their
originating platform.  Binary-incompatible v4 geometry database files
can be opened read-only within MGED where geometry can be inspected,
drawn, exported via the "keep" command, and updated to the newer
(platform-independent) v5 geometry database file format via the
"dbupgrade" command.  In order to override the otherwise automatic
binary-incompatible v4 detection, MGED's "opendb" command provides a
new -f flip option and all applications can override behavior with a
LIBRT_V4FLIP environment variable.

Also introduced with this release are numerous binary platform
integration and usability enhancements for Debian, Ubuntu, Fedora, and
other Linux platforms.  Included in Jordi Sayol's efforts are new
desktop icons, new menu items, mime-type association, and more.

* improved Fedora platform support with new menus, icons - Jordi Sayol
* fixed nirt units command reporting all units as invalid - Cliff Yapp
* dbupgrade support for binary-incompatible v4 files - Sean Morrison
* new opendb -f endianness flip option for corrupt v4 - Sean Morrison
* new mime-type geometry association for Debian platform - Jordi Sayol
* improved Debian platform support with new menus, icons - Jordi Sayol
* improved mged 'ls' command support for v4 databases - Sean Morrison
* dbconcat supports title, units, & color table import - John Anderson
* 'tree -a' command lists object attributes - Tom Browder
* fixed Mac build failure running asc2g before install - Sean Morrison
* fixed g_diff color table difference false positive - Sean Morrison
* fixed asc2g color table bug parsing 'color' lines - Sean Morrison
* 'attr show' command displays attributes sorted by name - Tom Browder
* fixed ted command to work using new editor support - Cliff Yapp
* fixed mged text editor invocation bug when editor wasn't installed
	- Sean Morrison, Daniel Roßberg, Cliff Yapp
* support for comment lines at beginning of .asc files - John Anderson
* disabled adrt_master and adrt_slave tools - Erik Greenwald
* ported pixblend image processing tool to Windows - Erik Greenwald
* upgraded libpng to version 1.4.5 - Cliff Yapp
* upgraded zlib to version 1.2.5 - Cliff Yapp
* removed shell execution ! command from vdeck - Cliff Yapp


----------------------------------------------------------------------
--- 2010-12-07  Release 7.18.0                                     ---
----------------------------------------------------------------------

This release includes the initial release of a new Bag of Triangle
(BoT) editing interface for MGED and Archer.  Nicholas Reed developed
the new graphical user interface (GUI) in order to consolidate the
numerous BoT editing commands and processing steps into one unified
easy-to-use interface.  The new GUI greatly simplifies BoT processing
steps and can save modelers considerable time.

* ported benchmark suite to Windows (requires 'sh') - Erik Greenwald
* improved NURBS wireframes with interior surface lines - Keith Bowman
* additional NURBS raytracing robustness improvements - Keith Bowman
* removed pl-sgi plot tool - Sean Morrison
* expanded rtarea documentation with examples and detail - Cliff Yapp
* improved support for unlimited object counts in mged - Sean Morrison
* fixed 'erase_all' behavior so 'who' gives correct lists - Bob Parker
* fixed idents, solids, and regions output - Bob Parker
* increased performance of facetization and export - Sean Morrison
* fixed NURBS raytrace bug grazing nearly flat surfaces - Keith Bowman
* fixed infinite loop bug converting to NMG and BoT - Sean Morrison
* improved Windows installer desktop shortcut creation - Bob Parker
* fixed running mged external tools (e.g., rt) after 'cd' - Bob Parker
* fixed 'pnts' point cloud primitive memory access bug - Richard Weiss
* new BoT editing interface for mged and archer - Nicholas Reed
* fixed crash during BoT decimation - Nicholas Reed
* improved robustness of CSG boolean tree processing - Sean Morrison
* improved loading of Pro/E export plugin on Windows - Bob Parker
* added ray bundle shooting capability to rtshot - Keith Bowman
* improved robustness of facetization and export - Richard Weiss
* cleaner logging of facetize command BoT failures - Sean Morrison
* removed 'query' command line prompting tool - Sean Morrison
* increased optimized package run-time performance - Sean Morrison
* fixed crash when raytracing multiple frames - Keith Bowman
* fixed mged zap crash while using preview - Keith Bowman, Bob Parker
* added ability to toggle mged status bar via .mgedrc - Rob Shinn
* new mged 'bot' command for accessing BoT properties - Nicholas Reed


----------------------------------------------------------------------
--- 2010-08-04  Release 7.16.10                                    ---
----------------------------------------------------------------------

The release concludes a phenomenal effort by Jesica Giudice who
meticulously translated approximately 150 pages of MGED tutorial
documentation from English to Spanish.  The 16 tutorials are now fully
converted and work continues on the technical side to develop
stylesheets for publishing corresponding PDF documents on the BRL-CAD
website.

* fixed nirt output formatting in MGED - Cliff Yapp
* rt can now output directly to PNG, among others - Erik Greenwald
* fixed crash-on-exit bug with iges-g importer - Richard Weiss
* fixed framebuffer shutdown and memory management bugs - Bob Parker
* added all remaining shape tools to the Windows build - Sean Morrison
* libpng updated from version 1.4.1 to 1.4.3 - Sean Morrison
* fixed crash tessellating pipes with maximum bends - John Anderson
* mged 'red' command no longer deletes custom attributes - Cliff Yapp
* fixed pixhalve memory leak and corruption on exit - Sean Morrison
* spanish translation for tutorial 9 - Jesica Giudice, Luciano Lamaita
* Tcl/Tk updated from 8.5.6 to 8.5.8 - Cliff Yapp
* spanish translations for tutorials 4-5, 7-8, 10-16 - Jesica Giudice
* fixed extrude object tessellation failures - Östen Lundahl
* added manual page for 'random' number generator tool - Sean Morrison
* added Tktable 2.10 external dependency for archer - Cliff Yapp
* fixed heap corruption writing NURBS sketch objects - Östen Lundahl
* added fullscreen display mode via F5 keybinding to ISST - Cliff Yapp
* restored archer view commands to work without a .g file - Bob Parker
* fixed memory leak in ISST during window resizing - Erik Greenwald
* fixed running multiple framebuffer servers concurrently - Bob Parker
* improvements to the primitive creation menu in archer - Bob Parker
* fixed crash using bot_split on non-"plate mode" BoTs - Bob Parker
* improved NURBS curve evaluation for mged brep command - Keith Bowman
* fixed OpenGL framebuffer Mac refresh bug - Sean Morrison, Bob Parker
* improved archer object list view - Bob Parker


----------------------------------------------------------------------
--- 2010-04-28  Release 7.16.8                                     ---
----------------------------------------------------------------------

BRL-CAD's ray tracing support for NURBS boundary representation
geometry objects continues to be developed towards providing a robust
foundation for supporting multiple-representation geometry.  This
release includes several NURBS ray tracing bug fixes, robustness
improvements, and trimming enhancements.

MGED receives a lot of attention towards improved stability with
numerous troublesome bugs getting fixed (e.g., "the Mac input bug"),
restoration of behavior for various introspective commands, and
continued feature integration with Archer.  MGED's wireframe display
gets a substantial 5x-10x performance improvement for non-Windows
platforms while MGED on Windows now supports 64-bit releases and
restores command-line scripting support.

Archer gets a user interface facelift with the introduction of a new
geometry browser, list view, buttons, and much more.  As Archer
approaches feature parity with MGED, it gets closer to an official
alpha release status as BRL-CAD's next generation geometry editor.

* find correct libpng version on Mac OS X 10.5+ - Sean Morrison
* fixed bot_dump crash with plate mode BoTs - Bob Parker
* fixed Mac OS X 10.5+ mouse input/rotation bug in mged - Bob Parker
* X11 wireframe performance improvements (dm 'X') - Sean Morrison
* rtarea "-u model" specifies output using local units - Keith Bowman
* new bot_split command separates BoTs into multiple BoTs - Bob Parker
* rtarea output provides various common larger units - Keith Bowman
* rtarea run within mged now displays using local units - Keith Bowman
* re-enabled archer's embedded image framebuffer - Bob Parker
* fixed mged and nirt crashes handling whitespace lines - Keith Bowman
* newly enhanced archer tree view hierarchy visualization - Bob Parker
* fixed nirt backout bug when origin was ahead of model - Keith Bowman
* fixed mged bug calling 'units' without a database - Erik Greenwald
* analyze, cat, dbfind, & 'l' describe selected objects - Cliff Yapp
* openNURBS updated to version 5.0 (2010-04-09) - Cliff Yapp
* improvements and bug fixes to NURBS ray tracing - Keith Bowman
* new button images and tree-view icons within archer - Cliff Yapp
* html man page viewing in archer - Cliff Yapp
* archer tree view colorization for selected objects - Bob Parker
* replacement of tkimg external dependency with tkpng 0.9 - Cliff Yapp
* libpng upgraded to 1.4.1 - Erik Greenwald
* fixed crash with solids/regions/idents mged commands - Sean Morrison
* g-stl and g-egg have new -8 marching cubes option - Erik Greenwald
* fixed mged bug reading from redirected input on Windows - Bob Parker
* fixed partition selection bug in rt -k cut plane - John Anderson
* added NURBS support for transformation matrices - Keith Bowman
* remap_mater mged command to change material codes - Paul Tanenbaum
* MGED help menu lists all commands with documentation - Cliff Yapp
* fixed mged units bug supporting decameter (Dm) units - Bob Parker
* improved robustness of NURBS trimming during raytrace - Keith Bowman
* Improved put_comb command usage and added documentation - Cliff Yapp
* mged finds g/pl asc tools, dbupgrade, and rt on Windows - Bob Parker
* Improve behavior of editor invocation in classic mode - Cliff Yapp
* reorganization of archer buttons, panels, & preferences - Bob Parker
* fix invocation of fbclear from MGED on Windows - Bob Parker
* fixed obj-g crash when importing multiple objects - Sean Morrison
* continued work on MGED Docbook man page conversions - Janine Gettier
* integration of mged authorship dedication into archer - Bob Parker
* improved behavior of mged initialization options - Bob Parker
* 3dm-g importer improvements for hierarchical layering - Keith Bowman
* fixed namespace initialization failure in rtwizard - Bob Parker
* removed the pcd-pix image conversion tool - Sean Morrison
* fixed coil tool -S option, now takes 6 parameters - Cliff Yapp
* fixed g-egg coordinate and polygon format bugs - Erik Greenwald
* improved obj-g import support for object names - Sean Morrison
* fix rtweight bug where incorrect units were reported - Cliff Yapp
* added initial manual page documentation for rtwizard - Sean Morrison
* support for metaball conversion to polygonal format - Erik Greenwald
* Tcl/Tk updated from 8.5.1 to 8.5.6 - Cliff Yapp


----------------------------------------------------------------------
--- 2010-02-04  Release 7.16.6                                     ---
----------------------------------------------------------------------

Considerable effort continues towards improving BRL-CAD's
documentation.  Janine Gettier has now converted the documentation for
approximately 200 of MGED's commands into the Docbook XML format.
Jesica Giudice has translated 4 of MGED's 16 introductory tutorials to
Spanish.  Cliff Yapp continues to work extensively with both to get
their efforts integrated so that HTML and PDF documentation are
cleanly generated.

* added dbot_dump to Archer for dumping displayed BoTs - Bob Parker
* added support to Archer for exporting view in OBJ format - Bob Parker
* new mvall command -f filename option for bulk renaming - Bob Parker
* fixed invocation of external editor for MGED commands - Cliff Yapp
* fixed BoT raytracing solidity failure on grazed edges - Keith Bowman
* increased 'rcodes' and 'edcodes' maximum line length - Sean Morrison
* increased maximum path depth supported by 'wcodes' - Sean Morrison
* extensive work on MGED Docbook man page conversions - Janine Gettier
* fixed unoriented BoT badmagic raytrace failure - Sean Morrison
* translation of mged tutorials 3 and 6 to Spanish - Jesica Giudice


----------------------------------------------------------------------
--- 2010-01-15  Release 7.16.4                                     ---
----------------------------------------------------------------------

* fixed gqa units argument parsing bug on 64-bit Linux - Sean Morrison
* bot_dump exports BoTs referenced within combinations - Bob Parker
* mged 'garbage_collect' validation care and bug fixes - Sean Morrison
* fixed mged 'view' command bugs setting quat and ypr - Sean Morrison
* improved rt reporting and exiting after prep failure - Sean Morrison
* fixed sorting bug in idents/regions/solids commands - Keith Bowman
* translation of mged tutorials 1 and 2 to Spanish - Jesica Giudice
* benchmark suite includes sysctl hardware information - Sean Morrison
* independent scaling of x/y/z axes for sca command - Richard Weiss
* ADRT cut mode now paints intersected regions - Erik Greenwald
* improved metaball primitive conversion support - Erik Greenwald
* new data_axes command added to archer - Bob Parker
* additional improvements to the step-g importer - Keith Bowman
* fixed mged "Pick Edit-Primitive" crash after killall - Sean Morrison
* configure --enable-strict-build compilation option - Sean Morrison
* librt now queries env LIBRT_DEBUG for more flags - Erik Greenwald
* pixdiff outputs matching pixels at half-intensity - Sean Morrison
* fixed rate interpolation bug in tabinterp - Emton


----------------------------------------------------------------------
--- 2009-11-06  Release 7.16.2                                     ---
----------------------------------------------------------------------

* continued expansion of the initial step-g importer - Keith Bowman
* added manual page documentation for pix-ppm command - Sean Morrison
* added -o file output option to pix-png and pix-ppm - Sean Morrison
* improved NURBS geometry raytracing support - Keith Bowman
* improved mged 'opendb' prompting - Sean Morrison, Jack Devanney
* renamed [diu]stat tools to dstats/istats/ustats - Sean Morrison
* improved obj-g ignoring textures and surface normals  - Keith Bowman
* added -n export surface normals option to bot_dump - Keith Bowman
* new archer plugin for displaying groups of attributes - Bob Parker
* added -R non-recursive option to mged 'keep' command - Sean Morrison
* fix crash of 'attach ogl' commands on OSX - Cliff Yapp
* added an mged menu option to change display managers - Cliff Yapp
* utilize new raytracing on old bspline/nurbs geometry - Sean Morrison


----------------------------------------------------------------------
--- 2009-09-29  Release 7.16.0                                     ---
----------------------------------------------------------------------

Considerable development continues towards improving BRL-CAD's
geometry support through the addition of several new geometry
importers.  This release includes initial support for 3DM (Rhino3D)
files, OBJ (Alias Wavefront) files, and STEP geometry (ISO 10303,
AP203) files.  Additionally, development on the Archer modeling tool
continues as MGED features are merged in and new features, such as
undo support and graphical editing, are expanded upon.

* initial step-g geometry importer - Keith Bowman
* added '-u' flag to 3dm-g - uses UUID for import names - Cliff Yapp
* improved fb-png and pix-png default gamma correction - Sean Morrison
* added a '-g' gamma correction option to pix-png - Sean Morrison
* added mged '-a' option for attaching display manager - Sean Morrison
* increased maximum size of framebuffer windows - Sean Morrison
* removed framebuffer option 'f' from interfaces - Sean Morrison
* reversed and simplified arguments to copyeval command - Bob Parker
* 3dm-g converter creates automatic top-level combination - Cliff Yapp
* added procedural 'human' generator command and gui plugin to archer
	- Stephen Kennedy, Bob Parker
* added BoT commands to archer (e.g., bot_flip, bot_sync) - Bob Parker
* implemented support for sub-object erasures - Bob Parker
* changed Pro/E exporter to output unoriented BoT objects - Bob Parker
* fixed a rendering bug with left-handed BoT objects - Bob Parker
* pipe now validates independent of parameter order - Daniel Roßberg
* added '-r' color randomize option to 3dm-g importer - Cliff Yapp
* enhanced '-v' verbosity option in 3dm-g importer - Cliff Yapp
* readded -A & -o attribute options to 'draw' and 'erase' - Bob Parker
* fixed bug in 'E' command to show object names - John Anderson
* initial obj-g geometry importer - Erik Greenwald
* Pro/E export plugin creates a 'Proe_Name' attribute - Bob Parker
* enhanced rtedge with antialias and both side options - Sean Morrison
* search command now works in Archer - Cliff Yapp
* make_bb now handles empty combinations correctly - Bob Parker
* no more rtweight crashing when PWD or HOME are unset - Sean Morrison
* fixed "Invalid NMG" empty output bug in g-stl - Sean Morrison
* improved BoT raytracing with vertex validation - John Anderson
* fixed Mac OS X 10.5 OGL and X11 display manager crash affecting mged
	- Sean Morrison, Mike Tegtmeyer, Tim Myers
* added experimental exporter to Panda3d EGG format - Erik Greenwald
* fixed compilation support for Mac OS X 10.5 - Sean Morrison
* new bb command creates & computes object bounding boxes - Cliff Yapp
* added -n "no-action" reporting option to edcodes & mvall - Bob Parker
* reordering of and additions to Archer button menu - Cliff Yapp
* extensive NURBS raytracing improvements - Keith Bowman, Cliff Yapp
* fixed mged bug when raytracing subpath context objects - Bob Parker
* added make_pnts for importing pnts data from file - Richard Weiss
* initial undo support for Archer - Bob Parker
* raytracers respect secondary ray overlap reporting - Sean Morrison
* add dynamic sampling for NURBS wireframe drawing - Cliff Yapp
* changed mged 'help' output formatting - Sean Morrison
* improved 'e_id' mged command help - Sean Morrison
* archer interactive editing support for most primitives - Bob Parker
* added '-v' to mged for version information - Erik Greenwald
* fixed the "scalloping" bug in the metaball primitive - Erik Greenwald


----------------------------------------------------------------------
--- 2009-05-11  Release 7.14.8                                     ---
----------------------------------------------------------------------

* fix trimming bug in tire tread for wide tires - Cliff Yapp
* archer interactive edit support for arb8, tor, ell, ehy - Bob Parker
* improved asc2g handling of large BoT conversions - Keith Bowman
* conversion of mged and archer to use new ttk widgets - Bob Parker
* fixed crash in raytracing of pipe when duplicate hit points returned
	- Cliff Yapp, Sean Morrison
* mged 'dbconcat' command no longer requires an affix - Bob Parker
* added 'l' describe support for the pnts primitive - Richard Weiss
* restored mged mirror command trailing axis options - Sean Morrison
* swapped meaning of -p and -o arguments to 'mirror' - Sean Morrison
* major overhaul of archer's appearance and layout - Bob Parker
* removal of archer's separate experience modes - Bob Parker
* add a left handed winding flag to the coil tool - Cliff Yapp
* add a clear command to MGED's command line - Cliff Yapp, Bob Parker
* initial implementation of a new 'pnts' primitive for point clouds
	- Nicholas Reed, Sean Morrison


----------------------------------------------------------------------
--- 2009-04-03  Release 7.14.6                                     ---
----------------------------------------------------------------------

* ported g_lint, g_diff, and g_transfer to Windows - Sean Morrison
* rtarea now computes center of area - Richard Weiss, Keith Bowman
* reduced archer's initial and maximum window size - Bob Parker
* BLT is no longer an archer/bwish external dependency - Bob Parker
* restored mged 'inside' command on edit state objects - Bob Parker
* adjust brlman script to use system man command - Cliff Yapp
* fixed small memory leak in gqa - Bob Parker
* implemented rtwizard perspective rendering support - Sean Morrison
* fixed rtwizard perspective and occlusion dialog bugs - Sean Morrison
* mged 'clone' command utilizes a new naming convention - Keith Bowman
* fixed mged bug mirroring rcc primitives - Keith Bowman
* modified rpp vertex ordering to match arb8 vertices - Keith Bowman
* fixed mged 'qorot' command rotation about point bug - Keith Bowman


----------------------------------------------------------------------
--- 2009-03-06  Release 7.14.4                                     ---
----------------------------------------------------------------------

Included in this release are various MGED bug fixes and enhancements.
The 'gqa' quantitative analysis tool is integrated into MGED and
receives numerous enhancements including computing moments of inertia
and calculating geometric centroids.  There is now also a new 'coil'
procedural geometry tool for generating coil shapes automatically
using the pipe primitive.

* fixed mged "Pick Edit-Primitive" mouse selection bug - Bob Parker
* improved mged command console cut-and-paste support - Bob Parker
* fixed mged command input last character bug - Bob Parker
* improved gqa file support for blank/comment lines - Bob Parker
* fixed several SMP threading bugs in gqa command - Bob Parker
* added centroids and moments of inertia to gqa command - Bob Parker
* fixed mged 'prefix' command to write renamed objects - Bob Parker
* update usage of tops command in geometry browser - Cliff Yapp
* fix description of u option in bo command's man page - Cliff Yapp
* add tool for automatic coil creation using pipe - Cliff Yapp
* fixed bugs with external tool invocation in mged - Sean Morrison
* mged 'make' command no longer doubles the view size - Sean Morrison
* added -R no-resize option to mged e/B/draw commands - Sean Morrison
* mged 'tops' command -g and -u options are deprecated - Sean Morrison
* added -Ap plot visualization option to mged gqa command - Bob Parker
* added new 'gqa' quantitative analysis command to mged - Bob Parker
* fixed mged view initialization bugs - Bob Parker
* integer values in mged without floating point noise - Sean Morrison
* fixed source distribution compile/install path error - Sean Morrison
* fixed mged switch error running the Primitive Editor - Sean Morrison
* fixed g_diff crash when comparing objects - Sean Morrison
* improved g_qa usage message and missing density message - Bob Parker
* fixed mged font preferences menu when ".mgedrc" present - Bob Parker
* fixed oed docs bug noting lhs/rhs must be displayed - John Anderson
* added the nmg_fix_normals command to mged - Erik Greenwald
* upgrade libpng to 1.2.35 (Security fix) - Erik Greenwald


----------------------------------------------------------------------
--- 2009-02-06  Release 7.14.2                                     ---
----------------------------------------------------------------------

This release includes a number of new tools and enhancements that
facilitate geometry import and export including a new 'bot_dump' tool
for extracting mesh models without evaluating them for solidity, a new
'dem-g' converter for importing Digital Elevation Model (DEM) data,
a new 'lens' tool for creating accurate optical lenses, and the dxf-g
importer receives a bug fix when importing 2D entities.

* fixed errors in handling of hyp primitive translations - Cliff Yapp
* g_diff now guesses if a change was evolutionary - Erik Greenwald
* added >, <, >= and <= attr value comparisons in search - Cliff Yapp
* fixed double-edged line segment sketch bug in dxf-g - John Anderson
* mged 'inside' command no longer uses edit state objects - Bob Parker
* reported and fixed mged documentation eto typein bug - Robert Penny
* fixed mged itcl.tcl startup failure prior to install - Sean Morrison
* fixed bot_dump -u command line option for setting units - Bob Parker
* changed automatic 'make' sizes for various primitives - Bob Parker
* fixed bug with mged 'make' command automatic keypoints - Bob Parker
* renamed all mk_ tools to remove the mk_ prefix - Sean Morrison
* more conversion of documentation to Docbook format - Janine Gettier
* removed the unused 'k'eypoint point on extrudes - Sean Morrison
* added new dem-g terrain importer - Richard Weiss
* layout tweaks to display of selection lists in archer - Doug Howard
* activate primitive creation buttons in archer - Bob Parker
* activate wizard plugins and add tire wizard to archer - Bob Parker
* new initial manual page for bot_dump - Sean Morrison
* added editing support for hyperboloid primitive to mged - Cliff Yapp
* new 'lens' procedural tool for making optical lenses - Cliff Yapp


----------------------------------------------------------------------
--- 2008-11-04  Release 7.14.0                                     ---
----------------------------------------------------------------------

Of the many enhancements included in this release, MGED gets a
powerful new command called 'search' that is very similar to the UNIX
'find' command but for geometry hierarchies.  Included in the
implementation of 'search' is the ability to list geometry that
matches a specified name using globbing patterns or regular
expressions.  You can also search for objects that have attributes
set, that are referenced in combinations, are at a particular depth in
the geometry hierarchy, and much more.  You can combine search
expressions together using boolean logic as well for even more
powerful operations.

* remove -empty option from mged "search" command - Cliff Yapp
* add -nnodes node count option to mged "search" command - Cliff Yapp
* upgraded libpng to 1.2.32 - Erik Greenwald
* fixed memory leak with in-memory geometry databases - Daniel Roßberg
* mged help menu is restructured for improved usability - Cliff Yapp
* update openNURBS to version 4.0.2007.0718 - Cliff Yapp
* handle (i.e., ignore) comments in asc2g conversions - Erik Greenwald
* fix crash in iges-g when run with -n option - John Anderson
* enhanced documentation management system within mged - Cliff Yapp
* conversion of documentation to Docbook format, editing, and review
	- Cliff Yapp, Janine Gettier
* improved benchmark suite usage and instructions - Sean Morrison
* improved mesh normals from Pro/E exporter - Bob Parker
* fixed 'bspline' surface primitive wireframe plot bug - John Anderson
* removed bot-raw, functionality replaced by bot_dump - Sean Morrison
* abort during non-planar collapse or simplify of NMG  - John Anderson
* jove is deprecated and will no longer be maintained - Sean Morrison
* plugged attribute memory leak in all database tools - Daniel Roßberg
* DSP tessellation honors cut type and handles zeros - John Anderson
* fixed 'gets' command input bug in mged - Sean Morrison, Bob Parker
* improved fast4-g DOS file line-ending support - Sean Morrison
* numerous documentation fixes to manual pages - Cliff Yapp
* bot_dump exporter for extracting BoT meshes unevaluated - Bob Parker
* fixed bug parsing long command lines in mged - Sean Morrison
* tessellation support for the DSP primitive - John Anderson
* additional logging options in Pro/E exporter - Bob Parker
* Pro/E exporter enhancements for dynamic tess tolerance - Bob Parker
* new search command enabling Unix find style searches - C. Yapp
* mged no longer requires PATH for internal commands - Sean Morrison
* mged 'edcolor' command turns into 'color -e' - Sean Morrison
* nirt dest command now avoids overwriting existing files - Cliff Yapp
* fixed mged_players error on tra in classic mode mged  - Bob Parker
* fix attr behavior when setting the region attribute - C. Yapp
* identified fix for "Illegal instruction" bug in rt - Simon Clubley
* mged get_regions and reid ignore duplicate regions - Sean Morrison
* added procedural geometry tools to the Windows port
	- Bob Parker, Andre Castelo
* integrated tgf-g with the default compile/install - Daniel Roßberg
* deprecated the mged '-n' option, use '-c' instead - Sean Morrison
* added the ability to invoke mged through icons/menus - Sean Morrison
* new -a option to mged 'killtree' for killing references - Bob Parker
* added new 'killrefs' command to mged - Bob Parker
* added -C color option to the mged 'E' command - Bob Parker
* fixed curvature calc bug in ehy primitive - Timothy Van Ruitenbeek
* added compilation support for MSVC 9 - André Castelo


----------------------------------------------------------------------
--- 2008-08-19  Release 7.12.6                                     ---
----------------------------------------------------------------------

This release enhances the formatting options available "out of the
box" for the NIRT tool, allowing users to easily select different
data reporting options without having to define their own custom
configuration files.  CSV output options also allow for quick
and easy import into spreadsheets.  The new -L option lists available
formats.

The tire tool's behavior has been improved - it will no longer
overwrite pre-existing files and a "w" flag now accepts a value of
"0" to disable creation of the default wheel rim for modelers wishing
to supply their own rim.  A number of small but visual flaws in the
tread geometry definitions were also corrected.

MGED's dbconcat command works again without needing to specifying an
affix for object names when importing geometry from one database to
another.  Primitive selection via the Edit menu is working again
thanks to the fixing of the solid_illum bug. The pipe primitive's
performance problems during raytracing, due to unnecessary memory
allocations, are now fixed.  The extrude primitive's handling of
invalid geometry is now more robust.

* renamed mged binary command to bo for binary objects - Sean Morrison
* fixed bug that caused remote framebuffers to fail - Sean Morrison
* add w option to tire to allow disabling wheel generation - C. Yapp
* tweak tread 2 in tire tool; avoid artifacts on tread wall - C. Yapp
* fixed mged 'dbconcat' hang when not specifying an affix - Bob Parker
* fixed primitive selection solid_illum bug in mged - Bob Parker
* fix bug in tire tool's geometry causing 'nicks' in tread - C. Yapp
* increased raytrace performance of pipe primitive - John Anderson
* fixed bugs handling invalid extrude objects - Sean Morrison
* fixed dependency bug in library pkg-config files - Sean Morrison
* platform installers now use a more consistent naming convention
	- Sean Morrison, Bob Parker
* added new -c character option to the loop command - Dawn Thomas
* tire now checks for files instead of overwriting - Cliff Yapp
* add new nirt formatting options, -L listing option - C. Yapp
* fixed nirt's dest cmd's handling of file name string - Cliff Yapp
* modified mged nirt command to include air in results - Bob Parker


----------------------------------------------------------------------
--- 2008-05-29  Release 7.12.4                                     ---
----------------------------------------------------------------------

This release contains numerous enhancements to MGED's mirror command,
now with the ability to mirror an object across arbitrary vectors or
points along a standard axis.  Additionally, nirt now has a new "gap"
option for reporting the empty spaces between objects on a given
shotline with additional formatting options under development.

The release also has a new procedural database geometry tool called
'tire'.  This new tool was developed by Cliff Yapp for the purpose of
creating highly detailed tires based on user-provided specifications.
Given standard tire dimension information, the program can generate a
corresponding curved sidewall tire on a fitted wheel and that has
detailed tread.  The results are impressively realistic tires.

* added '-l' list option to mged dbfindtree command - Bob Parker
* fixed minor memory leak during raytracing - Daniel Roßberg
* added '-+ t' rtcheck option to produce text plot output - Bob Parker
* added gap reporting option to nirt - Cliff Yapp
* added mirror command to archer - Bob Parker
* improve behavior of interactive nirt backout command - Cliff Yapp
* renamed mged dbbinary command to binary - Sean Morrison
* fixed rt/rtedge clipping bug - Bob Parker
* new mged mirror command options for arbitrary vectors - Bob Parker
* fix -k rt option to work for surface normal lighting - Cliff Yapp
* add tire proc-db for easy tire/wheel model creation - Cliff Yapp
* added query pixel support to the Windows framebuffer - Bob Parker
* mirror across a distance along a given axis in mged - Bob Parker


----------------------------------------------------------------------
--- 2008-04-23  Release 7.12.2                                     ---
----------------------------------------------------------------------

* new pinewood boxcar example geometry database - Cliff Yapp
* add mk_arb5, mk_arb6 and mk_arb7 to libwdb - Cliff Yapp
* added xclone command to mged for xpushed deep copies - Bob Parker
* fixed clone infinite loop for combinations - Sean Morrison, C. Yapp
* wrap mged resource paths with spaces - Bob Parker, Elena Bautu
* new -k 'cutaway view' option added to rt - John Anderson
* improved mged classic mode display manager selection - Sean Morrison
* fixed mged crash when getting forms of sketch objects - Bob Parker
* new -u units option added to rtarea - Sean Morrison
* added uniform binary object creation to mged GUI - John Anderson
* added e, l, o, i options to mged saveview command - Sean Morrison


----------------------------------------------------------------------
--- 2008-03-11  Release 7.12.0                                     ---
----------------------------------------------------------------------

Coalescing after just over a year of concentrated development efforts,
this release unveils a plethora of Windows-specific enhancements, bug
fixes, and additional tools ported.  Notably, the Windows improvements
include fixing various issues with file management and porting many
more ray tracers, geometry converters, framebuffer tools, and MGED
classic mode support.

This release also includes a new geometry converter for the United
Kingdom's INTAVAL format from Her Majesty's Ministry of Defence.  The
new importer was jointly developed by TNO PML and IABG mbH and is
included in the BRL-CAD sources as a contributed module.

Of the numerous bug fixes and feature enhancements in this release,
one of the biggest productivity enhancements is the addition of the
MGED "clone" and "tracker" commands.  Clone is a very powerful yet
simple command that provides an intuitive means for performing deep
copies of objects.  Tracker provides an interface for replicating
objects along a spline path.  These 'new' commands originate from
modifications originally developed by the now defunct Geometric
Solutions, Inc., and after receiving considerable updates and rewrites
are now once again available to users.

Finally, this release also marks a major change to the BRL-CAD source
code repository with a move from CVS to Subversion recently completed.
The conversion was successfully completed with the entire history of
BRL-CAD development preserved, accounting for nearly 25 years of
continuous active development.

* automatic redraw updates after Geometry Browser edits - Bob Parker
* improved Geometry Browser mouse behavior in mged - Bob Parker
* make fast4-g use GIFT_material=1 and los=100 - Sean Morrison
* fixed Mac OS X 'ogl' framebuffer crash - Sean Morrison, Bob Parker
* removed ogl framebuffer multiple window 'm' option - Sean Morrison
* tree -d option in mged for limiting tree display depth - Cliff Yapp
* added mouse color query support to OpenGL framebuffer - Bob Parker
* fixed X11 framebuffer colormapping bug - Bob Parker
* libpng updated to 1.2.25 - Erik Greenwald
* fixed several mged I/O bugs for stdin/stdout/stderr - Bob Parker
* nirt now uses bounding sphere for -b backout option - Erik Greenwald
* document the signals rt responds to for progress - Sean Morrison
* libpng updated to 1.2.24 - Erik Greenwald
* TCL/TK updated to 8.5.1 - Erik Greenwald
* mged now runs in the foreground by default - Erik Greenwald
* fixed g-dxf bug where incorrect object name is assigned - Bob Parker
* fixed browser-based mged help on Mac OS X - Sean Morrison
* added rest of BRL-CAD's geometry converters for Windows - Bob Parker
* added more missing framebuffer tools to Windows port - Bob Parker
* rtwizard enhancements for ghosting and display - Bob Parker
* mged reports failure if ray-tracer returns non-zero - Sean Morrison
* improved mged corrupt geometry file handling - Sean Morrison
* improved dbconcat object suffix and prefix options - Sean Morrison
* Tcl/Tk updated to 8.5 final from 8.5b1 - Erik Greenwald
* fixed PIX image file creation bug on Windows - Bob Parker
* ported rtwizard to function properly on Windows - Bob Parker
* fixed mged text-editing commands on Windows platform - Bob Parker
* removed duplicate points text-editing ARBs in mged - John Anderson
* improved mged ted line-ending support using wordpad - Bob Parker
* fixed g_diff bug where some differences were missed - John Anderson
* fixed bug evaluating metaball normals - Erik Greenwald, Ed Davisson
* improved metaball primitive rendering - Erik Greenwald
* fixed bug in mged rcc-cap command when using 't' option - Bob Parker
* mged classic mode now works on Windows platform - Bob Parker
* fixed Windows-specific raytrace framebuffer delay - Bob Parker
* new tracker tool for extracting NEWS tracker data - Sean Morrison
* converted source repository from CVS to Subversion - Sean Morrison
* new 'dir2ae' mged command for getting az/el from dir - Sean Morrison
* new 'ae2dir' mged command for getting dir from az/el - Bob Parker
* fixed empty name crash when using mged 'lt' command  - Sean Morrison
* Pro/E plugin allows spaces in part name mapping file - Sean Morrison
* Pro/E plugin creates 'top.#' if 'top' already exists - Sean Morrison
* fixed asc2g bug on Windows that caused a crash on exit - Bob Parker
* fixed bugs in several Utah Raster Toolkit tools - Pedro Giffuni
* fixed mged start-up initialization bug on Windows - Daniel Roßberg
* graceful handling of mesh normal failures - Sean Morrison
* fixed variety of g-iges and other exporter crashes - Sean Morrison
* fixed crash-on-exit cleanup bug in g-off exporter - Sean Morrison
* fixed crash when xpush was called on a primitive - Erik Greenwald
* fixed Windows port 'opendb' command crash - Bob Parker
* added configurable max_dist depth option to rtedge - Erik Greenwald
* added rest of BRL-CAD's ray-tracers to the Windows port - Bob Parker
* enabled embedded framebuffer support in Windows port - Bob Parker
* fixed garbled output during parallel crash reports - Sean Morrison
* fixed memory deallocation bug in the raytracers - Bob Parker
* renamed 'hd' hexadecimal dump utility to 'hex' - Sean Morrison
* renamed procedural 'wall' generator to 'masonry' - Sean Morrison
* mged 'tol' command now accepts multiple tolerances - Sean Morrison
* TCL and TK updated to 8.5b1. itcl/itk to dev 3.4. - Erik Greenwald
* fixed non-normalized vector bugs with ARBN objects - John Anderson
* pix-png warns if PNG is smaller than the PIX input - Sean Morrison
* new tgf-g INTAVAL importer - TNO PML, IABG mbH
* removed longjmp warning message from applications - Sean Morrison
* upgraded bundled incrTcl to version 3.3 - Erik Greenwald
* fixed bug with -g/-G cell size options to rt - John Anderson
* 'tree' command without args now shows e'd objects - Sean Morrison
* new pix-fb -p option to pause before exiting - Karel Kulhavy
* fixed mged 'B' command behavior with -A and no args - John Anderson
* updated bundled libpng to version 1.2.21 - Erik Greenwald
* removed raytrace image continuation code - Erik Greenwald
* new mged 'clone' command for performing deep copies of objects
	- Adam Ross, Sean Morrison, Erik Greenwald
* new mged 'tracker' object routing command - Sean Morrison
* fixed crash in mged ls -A attribute listing command - Sean Morrison
* fixed dbconcat of empty combinations, crash in mged - John Anderson


----------------------------------------------------------------------
--- 2007-10-24  Release 7.10.4                                     ---
----------------------------------------------------------------------

A major productivity change introduced in this release is
tab-completion in MGED.  John Anderson's addition of tab-completion to
MGED allows modelers to have command and object names automatically
completed when they press the tab key when operating on the MGED
command line.  If there are multiple matches, the user is presented
with the list of those possible matches, similar to what one might see
in a UNIX shell.

After much debate and demand, this minor release marks a rather
significant change in default behaviors for RT and MGED.  The
ray-tracers that utilize a framebuffer interface now all create
lingering windows by default instead of transient windows.  One of the
main impacts of this change is that users should no longer need to
specify the linger option when ray-tracing to a window via the -F
framebuffer option nor do they need to set the FB_FILE environment
variable in order to get the window to remain displayed.
Additionally, the default MGED preference setting for Z clipping is
now disabled in order to reduce confusion with clipped geometry.

* lingering framebuffer windows by default - Sean Morrison
* improved matrix readability on mged 'red' command - Karel Kulhavy
* "editor" for ted commands can be set in .mgedrc - Erik Greenwald
* fixed benchmark results computation on Solaris - Erik Greenwald
* fixed database corruption bug caused during dbconcat - John Anderson
* mirror BoT primitives - Sean Morrison
* BoT vertex selection in mged reports local units - Sean Morrison
* improved photon map irradiance progress reporting - Erik Greenwald
* tab-completion for mged - John Anderson
* quelled various flawfinder security issues - Erik Greenwald
* fixed photon-mapping lighting model crash - Erik Greenwald
* ADRT libtie bug fixes and performance enhancements - Justin Shumaker
* mged now tests for vim before vi for text editing - Sean Morrison
* fixed parallel operability bug on the Intel Mac - Erik Greenwald
* detect actual available CPUs on an Intel Mac - Erik Greenwald
* Z clipping now off by default in mged - Sean Morrison
* added pipe primitive performance optimizations - John Anderson
* handle discontinuous changes in pipe inner radii - John Anderson
* allow rt more than available cpus for debugging - Sean Morrison
* fixed small TGC (cone) primitive raytrace prep bug - Sean Morrison
* increased output precision from nirt/query_ray - Sean Morrison
* removed op-bw for reading Optronics Scanner images - Sean Morrison
* beset - Ben's Evolutionary Shape Extraction Tool - Ben Poole


----------------------------------------------------------------------
--- 2007-05-16  Release 7.10.2                                     ---
----------------------------------------------------------------------

* support infinite # of shadow rays in the raytracers - Sean Morrison
* improved anim_hardtrack manual page documentation - Erik Greenwald
* added 'bomb' command to mged for script termination - Sean Morrison
* mged and pl-X automatically focus to X11 on Mac OS X - Sean Morrison
* pl-X functionality enhancements for displaying plots - Sean Morrison
* fixed g_diff bug where -f option missed differences - John Anderson
* fixed mged 'units' command, reports current setting - John Anderson
* benchmark tool automatically logs all output to file - Sean Morrison
* added 'clobber' cleanup command to benchmark tool - Sean Morrison
* added NIST's Template Numerical Toolkit - Sean Morrison
* prevent pix-png from writing png data to a tty - Sean Morrison
* generate crash report files during application abort - Sean Morrison
* upgrade bundled tcl/tk from 8.5a5 to 8.5a6 (AquaTk) - Sean Morrison
* fixed memory leak in librtserver - John Anderson
* converters abort early on corrupted input geometry - John Anderson
* fixed versioning issues in source distributions - Sean Morrison
* new BRL-CAD installer for Windows using NSIS - Jonathan Bonomo
* added a brlcad-config configuration script - Sean Morrison
* added pkg-config files for core libraries - Sean Morrison
* fixed deadlock bug related to rtarea - Sean Morrison, John Anderson
* fixed bug in mged command prompt with page up/down - Sean Morrison
* added attr and make_name commands to archer - Bob Parker


----------------------------------------------------------------------
--- 2007-04-09  Release 7.10.0                                     ---
----------------------------------------------------------------------

With this release marks several significant changes to BRL-CAD's
licensing in order to simplify the distribution terms and increase
overall flexibility of use.  All application front-end code in BRL-CAD
is converted from the GNU General Public License (GPLv2) to the less
restrictive GNU Lesser General Public License (LGPLv2.1).

For documents not already in the public domain, BRL-CAD's default
documentation license terms are also changed from the dual-licensed
GFDL/GPL terms to the BSD Documentation License (BDL).  Originally
derived from the FreeBSD Documentation License, the BDL is effectively
the BSD License with language as it applies specifically to
documentation.  The terms of the BDL are just as flexible allowing
practically any use, whether it be commercial or private, so long as
the authors are appropriately credited.

As a collective work, BRL-CAD is being distributed under the terms of
the LGPL.  Individual portions of BRL-CAD, save for a few 3rd party
codes, effectively fall into one of the following three license
categories: 1) LGPL, 2) BSD/BDL, or 3) are in the public domain.  See
the terms of each individual license as well as BRL-CAD's COPYING file
for more details.

* fixed -i argument bug in g-acad, g-dxf, g-nff, g-obj - Shawn Baker
* framebuffer toggle added to raytrace panel in mged - Sean Morrison
* fixed rtedge multithreaded output render bug - Erik Greenwald
* fixed jove/termcap issues on Mac OS X - Sean Morrison
* increased output precision on mged 'analyze' command - Sean Morrison
* prevent mged shutdown on DSP objects with no data - Sean Morrison
* integration into the Arch Linux packaging system - Loui Chang
* upgrade of bundled tcl/tk from 8.4.6 to 8.5a5 - Sean Morrison
* improved EOL processing in 70+ tools - Sean Morrison, John Anderson
* rewrote pixcmp providing improved I/O format options - Sean Morrison
* added new manual page for pixcmp utility - Sean Morrison
* updated bundled zlib to version 1.2.3 - Sean Morrison
* updated bundled libpng to version 1.2.16 - Sean Morrison
* fixed Windows line-ending bug in dxf-g - John Anderson
* g_qa manual page documents the -t tolerance option - Lee Butler
* updated bundled blt to blt2.4z-patch-2 - Sean Morrison
* dxf-g turns 2D entities into sketches instead of nmg - John Anderson
* removed advertising clause from BSD code - Sean Morrison
* fix index bug, allow material ID of zero in rtweight - Karel Kulhavy
* fixed multiple frame render bug in raytracers - Karel Kulhavy
* mged help command now shows help for all args listed - Sean Morrison


----------------------------------------------------------------------
--- 2006-10-16  Release 7.8.4                                      ---
----------------------------------------------------------------------

* support for handling larger hierarchies in archer - Doug Howard
* added distance measurement tool to archer - Bob Parker
* added component selection capabilities to archer - Bob Parker
* new script to extract gforge task items - Lee Butler, Sean Morrison
* substantial additions and mods to source documentation - Lee Butler
* added scripts to facetize all regions in a database - Lee Butler
* added script to expand combinations to multiple objects - Lee Butler
* prevent infinite loop on classic mged attach prompt - Sean Morrison
* ctrl-d on empty shell line now quits mged - Sean Morrison
* added archer geometry/view loading via command-line arg - Bob Parker
* mged tree command now supports -o/-i, matches docs - John Anderson
* improved beginning-of-line input processing in stl-g - John Anderson
* improved end-of-line input processing in dxf-g - John Anderson
* support for longer Fastgen object names in fast4-g - Sean Morrison
* improved 'ted' mged command text editor support - Sean Morrison
* support mged EDITOR environment override on Windows - Sean Morrison
* fixed mged crash on P binding when not in edit mode - Sean Morrison
* improved FreeBSD 64bit support, fixes AMD64 crash - Erik Greenwald
* allow unlimited light samples during ray tracing - Sean Morrison
* new script for computing BRL-CAD file line counts - Sean Morrison
* fixed mged extrude of empty sketch display crash - Sean Morrison
* re-enabled png-ipu, pix-ipu, ipustat, ipuscan - Sean Morrison
* updated archer splash screen - Bob Parker
* archer enhancements for displaying view parameters - Bob Parker
* improved mged grid zooming using pixel size - John Anderson
* fixed mged hang caused by extreme grid zooming bug - John Anderson
* ported jove to SGI Altix platform, fixed crash bug - Sean Morrison
* increase default mged scrollback to 10k lines - Sean Morrison
* improved support for Mac "delete" keys in mged - Sean Morrison
* mged vi-mode command edit history searching - James (swcto)
* bigger, better vi command line editing in mged - James (swcto)
* rt command script 'ae' no longer resets view scale - Sean Morrison
* fixed asc-nmg manual page usage examples - Sean Morrison


----------------------------------------------------------------------
--- 2006-06-20  Release 7.8.2                                      ---
----------------------------------------------------------------------

This release includes a new example geometry model, a "Toy Barbie
Jeep" (see note below regarding trademarks) that was modeled in 2005
over the course of a day by a small group of students attending a free
hands-on BRL-CAD training class at SURVICE Engineering, Inc.  The
class involved working in groups to simulate a real-world
time-constrained modeling experience taking measurements of a real toy
vehicle, considering what aspects of the vehicle are important for
analytic purposes, deciding how to best represent complex geometric
shapes, modeling the parts of the vehicle in MGED, assembling the
components together, and running geometric processing and rendering
tools on the final model.

The DXF importer received considerable updates this iteration, with
John Anderson providing additional support for a variety of 2D DXF
entities.

* fixed asc-nmg bug that caused a crash on exit - John Anderson
* fixed minor mged memory leak - Jim Monte
* added archer version info to bottom of about dialog - Bob Parker
* added a beta vertex array exporter (g-var) - Prasad Silva
* archer support for multi-select and cut-n-paste - Doug Howard
* added newly supported entities to dxf-g manual page - John Anderson
* fixed asc2g bug reading files with carriage returns - Sean Morrison
* added dbupgrade manual page - Sean Morrison
* updated the g2asc manual page with format details - Sean Morrison
* fixed g_diff attribute comparison issue - Sean Morrison
* g_diff reports more detail whether differences exist - Sean Morrison
* g2asc now saves additional _GLOBAL attribute values - Sean Morrison
* fixed g2asc export of null units bug - Sean Morrison
* fixed libwdb corruption when creating pipes - Daniel Roßberg
* fixed crash in release build concerning bot's - Daniel Roßberg
* new toy barbie jeep geometry - Various Students
* considerable dxf-g enhancements, more entity support - John Anderson

Note: Barbie and Jeep are trademarks of Mattel Inc. and the
Daimler-Chrysler Corporation respectively.  No endorsement is intended
or implied.

----------------------------------------------------------------------
--- 2006-04-11  Release 7.8.0                                      ---
----------------------------------------------------------------------

This release marks a major milestone in the massive effort by the
BRL-CAD developers and the open source community to provide a complete
port of BRL-CAD to the Microsoft Windows platform.  This effort
includes particular support and contributions from SURVICE
Engineering, Inc., TNO Prins Maurits Laboratory, the U.S. Army
Research Library (ARL), and others.  The Windows port effort was
started several years ago, primarily through efforts of friends at the
U.S. Army Aviation and Missile Research Development and Engineering
Center (AMRDEC) and CG2, Inc.  Over the past year, the development
effort was accelerated to a stable status through the work of SURVICE
working for ARL.

This release also includes another major contribution by SURVICE
Engineering, Inc., a new modeling tool called Archer.  A more detailed
announcement and overview of Archer will be given in the near future
after the new tool is more fully integrated into the build system and
tested further.

Other noteworthy enhancements provided in this release include new
sample applications that demonstrate the capabilities of the libpkg
networking library, in-memory geometry database processing, reshooting
of rays from analysis codes for testing purposes, and the librt root
solver.  For analysts and modelers alike, the MGED modeler also
acquires a few new commands including reid and remat that respectively
assist with the assignment of region and material identifiers.

* fixed mged B command bad geometry resource bug - John Anderson
* new tracker tool for extracting sf.net tracker data - Sean Morrison
* added manual page for benchmark tool - Sean Morrison
* fixed g-dxf export compatibility issue - John Anderson
* smoother sketch primitive spline drawing - Sean Morrison
* fixed read bug in giftorle - Sean Morrison
* fixed multiply referenced object illumination bug - Sean Morrison
* improved nmg tessellation support reliability - Sean Morrison
* new tpkg ttcp-style example application using libpkg - Sean Morrison
* new roots_example root solving sample application - Sean Morrison
* prevent several g-nmg segfaults during tessellation - Sean Morrison
* fixed brlman/awf `./"' unsupported or unknown issue - Sean Morrison
* new g_transfer in-memory geometry example program - Sean Morrison
* new reshoot program to reshoot rays & compare results - Lee Butler
* added support for -F framebuffer option to fb-bw - Sean Morrison
* reid mged command, recursively assign region IDs - Sean Morrison
* remat mged command, recursively assign a material ID - Sean Morrison
* get_regions mged command, list assembly regions - Sean Morrison
* extensive Windows build support enhancements - Bob Parker
* new Archer modeling and visualization tool - Bob Parker, Doug Howard
* raytracers use image size for default aspect ratio - Sean Morrison
* fixed benchmark sqrt of negative numbers error - Sean Morrison
* raytracer performance enhancements - Sean Morrison


----------------------------------------------------------------------
--- 2005-12-15  Release 7.6.6                                      ---
----------------------------------------------------------------------

Continuing with the newly added point collection and reverse modeling
techniques provide in the previous release, this iteration improves
upon that support fixing several issues and refining the modeling
techniques.  Additionally, after more than a year of passively
researching and investigating, this release now accounts for the
majority of known contributors to BRL-CAD over the project's
existence.  This is part of an on-going effort to document the history
of BRL-CAD over the past 20 years.

* improved mged resource searching when not installed - Sean Morrison
* significant AUTHORS file updates, all names filed - Sean Morrison
* fixed sketch primitive bezier path computation bug - Sean Morrison
* cleaned up erroneous rtedge end of line output - Sean Morrison
* configure --enable/disable-everything option - Sean Morrison
* updated g_qa manual page documentation - Lee Butler
* early termination grid spacing limit bug in g_qa fixed - Lee Butler
* fixed Jove sandbox installation issue - Sean Morrison
* fixed adrt/isst client crash bug - Mike Caruso, Razak Arunaogun
* fixed modified env(PATH) startup issue in mged - Sean Morrison
* fixed benchmark tool default resource location bug - Sean Morrison
* added another text alignment handler to dxf-g - John Anderson
* clamped integer value printing of primitives in mged - Sean Morrison
* removed gratuitous nmg debug printing from mged - Sean Morrison
* fixed grouping bug, mged point importer - Jason Owens, Sean Morrison
* improved mged point import support - Lee Butler, Sean Morrison
* fixed bug in plate orientation of mged point importer - Lee Butler


----------------------------------------------------------------------
--- 2005-11-12  Release 7.6.4                                      ---
----------------------------------------------------------------------

This release adds a new geometry creation interface to MGED that
supports reverse modeling geometry of existing objects.  New geometry
creation commands read point data sets in a simple text file format,
recognizing categories and collections of points.  Using
point-acquisition devices such as X-Station Vulcan advanced surveying
systems from Arc Second Inc., points may be collected and used in MGED
to facilitate the generation of geometry models.  Collection
techniques are recognized for polygonal plates, cylinders, spheres,
point clouds, and more.

* auto-locate mged external apps regardless of PATH - Sean Morrison
* mged utilizes a local display if unspecified/unset - Sean Morrison
* set default mged Escape key binding to reject - Sean Morrison
* fixed 'benchmark' tool resource searching - Sean Morrison
* added -u option to mged "make_bb" to allow air - Lee Butler
* fixed IBM AIX compiler support issues - Sean Morrison
* head/tail -n usage posix compliance - Stefan Fiedler, Sean Morrison
* fixed jove compilation issues - Sean Morrison, Daniel Remenak
* fixed conversion bug in the dxf-g converter - John Anderson
* point parsing/import interface to mged - Sean Morrison, Lee Butler
* fixed bug in export of NMG primitives - John Anderson
* fixed itcl configuration issue - Stefan Fiedler, Sean Morrison
* fixed g_qa tolerance option parsing inconsistency - Sean Morrison
* improved mged 'tol' command tolerance value checks - Sean Morrison
* fixed tgc absolute tessellation tolerance issue - Sean Morrison
* optional build support checks for X11 and OpenGL - Sean Morrison
* improved Windows build support - Bob Parker, Daniel Roßberg
* isst observer 2x screen magnification - Justin Shumaker
* added los and material name support to librtserver - John Anderson
* improved 64bit support for ADRT - Justin Shumaker
* updated manual page documentation - Sean Morrison
* added support for text handling to dxf-g - John Anderson


----------------------------------------------------------------------
--- 2005-09-29  Release 7.6.2                                      ---
----------------------------------------------------------------------

In order to resolve an integration issue with the MUVES-S2
vulnerability analysis code, this special release of BRL-CAD was put
together providing updated tclscripts that work correctly when
embedded into MUVES-S2.  This release also facilitates BRL-CAD's
integration with AJEM as well for their corresponding release.

* fixed 'embedded mged' tclscript files - Karen Murray, Sean Morrison


----------------------------------------------------------------------
--- 2005-09-08  Release 7.6.0                                      ---
----------------------------------------------------------------------

This release includes the addition of a new geometry "Quantitative
Analysis" tool called g_qa.  This tool is a new tool that combines
some of the features of rtweight, rtcheck and g_lint, providing a
robust means for computing the weight and volume of objects while also
allowing a means to report overlaps, air gaps, external air regions,
bounding box dimensions, and more.

* configuration build fixes for Tk/Iwidgets - Michal Slonina
* fixed bug in mged overlay command handling of EOF - Lee Butler
* renamed g-wave converter to g-obj - Sean Morrison
* mged will now work without being installed - Sean Morrison
* improved ADRT build support - Sean Morrison
* improved build support detection for OpenGL and X11 - Sean Morrison
* performance enhancements to ADRT - Justin Shumaker
* enabled SGI knobs and button box support for IRIX - Sean Morrison
* fixed mged startup resource bug - Enrique Perez-Terron
* Enhancements to g_qa for stability and performance. - Lee Butler
* 'make test' now runs against an uninstalled  build tree - Lee Butler
* new nightly regression test framework - Lee Butler
* g_qa now has option to report interfaces/connections - Lee Butler
* mged relocation support - Sean Morrison
* Doxygen changes to source code comments - Lee Butler, Sean Duvall


----------------------------------------------------------------------
--- 2005-08-10  Release 7.4.2                                      ---
----------------------------------------------------------------------

Continuing with the impressive ADRT tool suite being provided by
Justin Shumaker is the addition of the Interactive Shot Selection Tool
(ISST).  Using ISST, you can spin large facetized models around in
real-time, slice through them with rays, and examine the geometric
components along a given path.  The tool will take advantage of
clusters and SMP hardware similar to RISE, providing a master job
manager, a slave compute daemon for network distributed processing,
and a client for interacting with and viewing the models.

* fixed ray-trace unique hits evaluation bug - John Anderson
* added manual page for remapid - John Anderson
* fixed quick memory debugging bug - Jim Hunt
* improved brlman relocation - Sean Morrison
* added g_qa geometry quality analysis tool (beta) - Lee Butler
* added adrt interactive shot selection tool - Justin Shumaker
* simultaneous -o and -F options to rt, rtedge, rtxray - Sean Morrison

----------------------------------------------------------------------
--- 2005-07-12  Release 7.4.0                                      ---
----------------------------------------------------------------------

This update includes several enhancements and new additions including
the impressive addition of the Realistic Image Synthesis Engine (RISE)
path-tracer.  RISE is part of the Advanced Distributed Ray-Trace
(ADRT) tool and library suite, which provides a high-performance
triangle ray-trace engine.  This engine serves as the basis for
several tools, RISE being the first toolset to be released.  This
toolset includes a master job manager, a slave compute daemon for
network distributed processing, and a client for observing job
progress.

Driven by user requests, the 'rtarea' command now reports significantly
more information than before including area details for all assemblies
and regions being rendered.  Both the presented and exposed areas are
now computed too, including details on how many regions/assemblies are
hit.  The exposed area is the potentially occluded 2D projection
whereas the presented area is calculated without consideration for
occlusions.  That is to say that if an object is in front covering a
regions or assemblies from a particular view, the exposed area of the
covered geometry would be reduced but the presented area would not.
The rtarea command was added to MGED as well, along with rtweight.

* improved mged initialization failure reporting - Sean Morrison
* applied zlib vulnerability patch (CAN-2005-2096) - Sean Morrison
* added the adrt rise path-tracer - Justin Shumaker
* increased mged shadow ray selection max to 64 - Sean Morrison
* added rtarea and rtweight commands to mged - Sean Morrison
* added sorting and hierarchy support to rtarea - Sean Morrison
* rewrote rtarea for region and assemblies support - Sean Morrison
* fixed .density file parser bug in rtweight - Daniel Roßberg
* improve detection and handling of cyclic geometry - Sean Morrison
* added a -noleaf option to the mged pathlist command - Bob Parker
* fixed potential infinite loop bug in BoT primitive - Bob Parker
* no longer install tclsh/wish, use btclsh/bwish - Sean Morrison
* added bot_merge mged cmd (combine 2 bots into 1) - Lee Butler

----------------------------------------------------------------------
--- 2005-06-07  Release 7.2.6                                      ---
----------------------------------------------------------------------

Additional modifications were made to the benchmark suite including
the addition of iterative frames that compare the stability of the
performance results being observed.  The benchmark will continue to
render frames of a designated time-complexity until the numbers are
either stable or a maximum time window is reached.  The benchmark
output now describes what the results mean and provides reference
numbers for comparison.  The benchmark suite is also now included in
the default installation as a command-line tool named 'benchmark'.

In conjunction with the benchmark suite's requirements, some example
geometry databases are now provided as part of the default install as
are the corresponding reference benchmark images and logs.  They are
intended to provide new users with sample geometry models to work
with; and custom configurations may disable the installation of the
additional geometry databases if so desired.

* documented the rtcheck -g and -G options - Sean Morrison
* fixed units bug in mged typein of bot and arbn - Daniel Roßberg
* added -W option to raytracers for white background - Sean Morrison
* synchronized mged startup message with gui creation - Sean Morrison
* added -f option to mged to prevent backgrounding - Sean Morrison
* install example geometry databases - Sean Morrison
* added 'benchmark' tool and install benchmark suite - Sean Morrison
* improved installation instructions - Sean Morrison
* fixed various typos in top level documents - Chuck Kennedy
* added summary and explanation of benchmark results - Sean Morrison
* fixed dimension conversion bug in dxf-g - John Anderson
* added deviation stability checks to benchmark suite - Sean Morrison


----------------------------------------------------------------------
--- 2005-05-11  Release 7.2.4                                      ---
----------------------------------------------------------------------

The release marks the beginning of a series of benchmark suite
enhancements.  The benchmark suite will now iteratively increase the
number of rays being shot until a minimum amount of time has elapsed
per render.  The resulting computations provide a more stable
ray-trace figure of merit (rtfm) and allows the benchmark tests to
scale more effectively to increasingly higher-performance machines
without requiring intervention.  The current default testing time
window minimum of 60 seconds elapsed wallclock time implies that the
benchmark suite will now take about 15 minutes to complete.

* fixed libbu run-time memory corruption checking - Sean Morrison
* prevent indirect OpenGL framebuffers from crashing - Sean Morrison
* throttle cpu usage on lingering OpenGL framebuffers - Sean Morrison
* uniform binary objects from partial file data - Sean morrison
* added libwdb interface to uniform binary objects - Sean Morrison
* fixed mged help for whichid, whatid, and whichair - Sean Morrison
* fixed dsp primitive bug when using binary objects - Sean Morrison
* fixed tabsub 64bit filesystem file read bug - Sean Morrison
* vrml-g now writes out DEF names for exported shapes - Sean Morrison
* updated manual pages with new contact details - Sean Morrison
* iterative scalable benchmark computations - Sean Morrison
* added logging of ray details when root solver fails - Sean Morrison
* added logging of solid name when root solver fails - Lee Butler
* build now includes a termlib library - Sean Morrison
* fixed smp linux rtarea calculation bug - Sean Morrison
* fixed rtweight centimeter units computation bug - Lee Butler
* fixed asc2g double-free warnings bug - Sean Morrison
* added rtarea manpage documentation - Sean Morrison
* fixed compilation support for Solaris - Sean Morrison
* removed redirection usage examples in g2asc docs - Sean Morrison


----------------------------------------------------------------------
--- 2005-04-03  Release 7.2.2                                      ---
----------------------------------------------------------------------

* fixed rtedge/rtwizard background render failure bug - Sean Morrison
* fixed rttherm previous results interference bug - Sean Morrison
* fixed aborted benchmark summary bug - Sean Morrison
* renamed the irprep 'display' tool to 'showtherm' - Sean Morrison
* quelled XInputExtension warning on mged startup - Sean Morrison
* fixed non-square window mged illumination selection - Sean Morrison


----------------------------------------------------------------------
--- 2005-03-05  Release 7.2.0                                      ---
----------------------------------------------------------------------

* fixed libpng link bug on Irix64bit - Lee Butler
* fixed locale build bug - Thierry Thomas & Pedro Giffuni
* fixed g-iges stdout header bug - Manfred Spraul
* fixed minimal BoT disappearance bug  - Lee Butler
* Sketch Editor now starts with an empty sketch - Sean Morrison
* fixed need for brlcad_root on default configure - Sean Morrison
* update to zlib 1.2.2 - Sean Morrison


----------------------------------------------------------------------
--- 2005-01-25  Release 7.0.4                                      ---
----------------------------------------------------------------------

This patch release update fixes several build issues experienced on
various platforms including Gentoo, Debian, and Mac OS X.

* provided libutahrle (urt) vulnerability patch - Pedro Giffuni
* fixed missing vgr results when missing dc - Sean Morrison
* update of Utah Raster Toolkit from 3.0 to 3.1b1 - Sean Morrison
* update of libpng from 1.2.5 to 1.2.8 - Sean Morrison
* gentoo build fixes - Cliff Yapp


----------------------------------------------------------------------
--- 2005-01-07  Release 7.0.2                                      ---
----------------------------------------------------------------------

This release marks the first source and binary distribution of BRL-CAD
as an Open Source project.  With the exception of a few minor bug
fixes, the majority of changes made available through this release
that separate it from 7.0.0 are source code style adoptions and
clarifications of the developer documentation.  All files have adopted
an emacs/vi local variables block for style conformance and the source
code headers are modified to denote the new distribution and copyright
status of the project.


----------------------------------------------------------------------
--- 2004-12-21  Release 7.0.1                                      ---
----------------------------------------------------------------------

While with the new release numbering scheme it will be rare to see a
release with an odd minor patch number, in many ways this is a major
BRL-CAD release with the package entering the realm of Open Source
software.  Likewise, the project moves a new public website as well as
adopts a SourceForge project site.  With the migration of the project
to SourceForge, new forums, mailing lists, bug tracking, feature
requests, support mechanisms, task management, and news announcement
channels all become instantly available.

OPEN SOURCE

This marks the first release of BRL-CAD as Open Source software.  It
has taken several years and much hard work by many people to actually
make this happen.  Special thanks goes out to the U.S. Army Research
Laboratory for giving back to the community by allowing BRL-CAD to be
released as Open Source software under the Open Source Initiative
(OSI) approved NASA Open Source Agreement (NOSA).  The "release"
solely exists in CVS -- binary and source distributions will remain
unprepared.

The majority of BRL-CAD is covered by the GNU General Public License.
The BRL-CAD libraries (src/lib*) are all provided under the GNU Lesser
General Public License.  The documentation is provided under the terms
of the GNU Free Documentation License.  The build infrastructure and
supporting scripts are covered by the Berkeley Software Distribution
license or are in the public domain.  Given the vast size, complexity,
and varied usage needs of BRL-CAD's source code and supporting data,
all of the aforementioned licenses allow for a greater degree of
flexibility in how they may be used.

See the individual files in question and the COPYING file for more
details.  The licenses are intended to foster and encourage
improvements to BRL-CAD and the Open Source community as a whole
without taking away from the package's heritage and history.  See the
COPYING file for more details and information.


----------------------------------------------------------------------
--- 2004-11-01  Release 7.0.0                                      ---
----------------------------------------------------------------------

BRL-CAD's source code has undergone major restructuring with a
complete replacement of the build system and conversion of the sources
toward standards compliance.


SOURCES REORGANIZED

This release of BRL-CAD marks a new beginning for the project in terms
of how to sources are organized and how the package is built.  BRL-CAD
now uses the GNU Build System (autotools) for compilation.  The gen.sh
and Cakefile-based build system is no more.  In addition to a new
build system, the directory hierarchy has been reorganized.

Following the GNU-style source code reorganization, BRL-CAD will now
also follow the major.minor.patch (e.g. 7.0.0) version numbering
convention.

Source code now primarily lives under the top-level src/ directory,
external libraries are in the src/other/ directory.  Several of the
third-party libraries have been updated including tcl/tk and libpng.
There are top-level documentation files available (such as this file
and the README) to get users familiar with the project.  Developers
that would like to get involved with BRL-CAD should refer to the
HACKING file.


ANSI CONFORMANCE

As for the source code itself, full K&R conformance has finally been
let go with the new preference of being fully compliant with the ANSI
C standard (INCITS/ISO/IEC 9899-1999).  More efforts continue to
complete this conversion, maintaining support for as many of the older
compilers as is reasonably possible, as well as general source code
clean up.  See the new HACKING file for for more information.


NEW FEATURES

The enhancements evident in this release of BRL-CAD include dozens of
bug fixes and additional documentation across the entire package.
MGED now sports a new Geometry Browser for traversing through
geometry, as well as improved support for saving and restoring MGED
views.  There is now support for importing from Unigraphics and
Pro-Engineer with the ug-g and proe-brl converters.  There is also a
g-nff converter for exporting to the NFF file format.  There is
experimental initial support for a new super ellipsoid primitive type
for advanced curvature shapes.  There are a few new procedural
database generators including one for creating geometry of an image as
well as generic vegetation.


WINDOWS SUPPORT

This release marks the first release with initial support for the
Windows operating system platform.  All of the core BRL-CAD libraries
as well as several tools (including MGED, RT, NIRT, ASC2G, and more)
have completed the conversion.  While not yet a holistic port, all of
the libraries and the core utilities have been ported and the rest will
soon follow.


----------------------------------------------------------------------
--- 2002-09-13  Release 6.0.2                                      ---
----------------------------------------------------------------------

Bug fixes.


----------------------------------------------------------------------
--- 2002-07-02  Release 6.0.1                                      ---
----------------------------------------------------------------------

Bug fixes.


----------------------------------------------------------------------
--- 2002-03-02  Release 6.0                                        ---
----------------------------------------------------------------------

NEW DATABASE FILE FORMAT

This is probably the most significant change in this release.  It
introduces a large number of new capabilities in BRL-CAD, including:

* Machine-Independent Data

  The geometry in the new file format is stored in an
  architecture-independent fashion. This removes the need to convert
  the geometry file to ASCII representation and back to binary when
  moving between machines of different architectures (e.g., between
  Big-Endian and Little-Endian machines).

* Unlimited-Length Object Names

  Names of objects in the geometry database were previously limited to
  16 characters. This restriction was burdensome when constructing
  complex systems. The new database format (and MGED/RT) allows for
  unlimited-length names for objects. The only limits remaining are
  usability/human factors (i.e., the user may wish to think twice
  before using 1024-character names for all objects).

* Object Attributes

  All geometry file objects can now carry arbitrary text data. This
  information is stored as a series of name-value pairs. For example,
  it is possible to store an attribute called "modeler", which could
  indicate the name and organization of the person who created that
  portion of the geometry. Another attribute might be "density", whose
  value would be the density of the material from which the object was
  constructed. Analysis codes can store application-specific data in
  these attributes and retrieve them at run time. MGED has a GUI
  control panel for creating and editing object attributes.

* Opaque Binary Objects

  It is now possible to store arbitrary data in a BRL-CAD geometry
  database object. For example, the entire description from an
  external CAD system could be stored for reference. Several features
  of BRL-CAD geometry that require ancillary data can now use these
  database objects as a data source in addition to being able to use
  external disk files.

* Reduced Disk Space Requirements

  The new file format is more aggressive about space utilization. Many
  primitives now occupy significantly less disk space.

* New dbupgrade Utility for Easy Migration

  The dbupgrade command has been created to bring old databases up to
  the most current version of the file format.

* Hidden Objects

  It is now possible to mark objects in the database as
  "hidden". These will not be listed in ordinary displays of database
  content. This allows users to keep objects such as opaque binary
  objects from cluttering listings.

* Deprecation of Obsolete hf and poly primitives

  The dsp(Displacement Map) primitive is functionally equivalent to
  the hf and offers substantial performance advantages. The bot (bag
  of triangles) primitive is likewise a substantial improvement over
  the existing poly primitive. The dbupgrade utility converts existing
  hf and poly primitives into dsp and bot primitives,
  respectively. Both hf and poly primitives are deprecated.

* Introduction of 2D sketch primitive

  The sketch primitive consists of straight lines, circular arcs, and
  Bezier curves. There is a drawing utility in MGED for creating them.

* Introduction of extrude primitive

  The extrude primitive supports linear extrusion of closed-boundary
  sketch primitive drawings to create 3D objects.

* New ASCII File Format for New Binary File Format

  This new ASCII format is based upon the Tcl scripting language. It
  allows more convenient processing and manipulation of the ASCII
  format.


MGED GEOMETRY EDITOR IMPROVEMENTS

In addition to supporting both the old and new geometry file formats,
there have been numerous improvements. These include:

* New User's Manual

  This is a completely updated tutorial introduction to MGED and
  modeling with BRL-CAD. Delivered in PDF format and suitable for both
  online browsing and printing. It includes a complete command
  reference. Look for it in the MGED menus at: "Help->Manual->PDF MGED
  Tutorial"

* Dual-Format Capability

  MGED and other BRL-CAD utilities retain the ability to work with
  geometry files constructed in previous versions of BRL-CAD as well
  as the new one. Users can upgrade geometry to the new format when
  they choose. New features implemented in the geometry file may not
  be available under the old format.

* Accelerators for Complex Shape Construction

  These allows user to automatically generate more complex primitives
  from existing ones. For example, rcc-cap creates an ellipsoidal top
  for a right circular cylinder.  The list of accelerators includes:
  rcc-blend, rcc-cap, rcc-tgc, rpp-arch, rpp-cap, rpp-arch, tor-rcc,
  and sph-part.

* Improved Menu and Interface Layout

  Menus have been arranged in a more convenient layout.  Default color
  selections have been improved.

* Abort on Raytrace Control Panel

  Users now have the option to abort a running raytrace process right
  from the control panel.

* Extended Primitive Type-In Support

  Two primitive types can now be created from the command
  prompt. These include:

    o  kinematics control (grip)
    o  arbitrary regular polyhedron (arbn)

* Extended Primitive Auto Generation

  Several primitive types can now be auto generated using the make
  command from within MGED.  Primitives created with this command take
  their initial parameters from the view center and size.  These
  include:

    o  rectangular parallelepipeds (rpp)
    o  arbitrary faceted (ars)
    o  and arbitrary regular polyhedron (arbn)

The following new commands and MGED tools have been implemented:

  * E: Extended options for creating evaluated wireframes.

  * adjust: Alter attributes of an object.

  * attr: Assign or retrieve a named text attribute from an object.

  * autoview: Set view size and center so that all displayed solids
    are in view.

  * bot_decimate: Perform facet reduction on bot by edge collapse.

  * bot_face_sort: Optimize a bot primitive for faster raytracing.

  * copyeval: Copy and evaluated/transformed primitive.

  * hide: Mark database object as hidden.

  * unhide: Mark database object as visible.

  * lt: Produce a listing like ls, but display output in a
    Tcl-friendly format.

  * nmg_collapse: Perform facet reduction on NMG by edge collapse.

  * nmg_simplify: Attempt to convert NMG to CSG primitive (ARB, TGC).

  * pathlist: Lists all existing paths that start from the specified
    combinations and end at a primitive.

  * rtedge: Command line interface to the rtedge program for
    generating line drawings.

  * shells: Separates an NMG primitive into many objects, 1 object per
    NMG shell.

  * showmats: List transformation matrices on a path.

  * summary: Provide database statistics.

  * xpush: An extended push that attempts to avoid degenerate
    conditions in matrix propagation.

  * Build Pattern Tool: this tool facilitates the construction of
    replicated objects in various rectangular grid and circular
    patterns. For example: lines of rivet heads, bolt holes, railroad
    ties, tire tread patterns.


OTHER ENHANCEMENTS

  * Opaque Binary Object Support for dsp Primitive and Texture Shaders

    The dsp primitive can accept an opaque binary object as the source
    for its elevation data. Likewise, texture shaders can now accept
    opaque binary objects as the source for their image data.

  * Improved bot Primitive Raytracing

    The bot primitive supports a multiple bounding-box technique to
    achieve a substantial speedup during raytracing.

  * Improved dsp Primitive Raytracing

    The bot primitive implements an octtree bounding-box technique to
    achieve a substantial speedup during raytracing.

  * ASCII Representation for ebm and vol Primitives

    These two primitives did not have an ASCII representation in
    previous releases. This omission has been corrected.

  * Support for MacOS X

    BRL-CAD again supports the MacOS platform. It requires that the
    XDarwin or other X11 server be installed for correct operation.

  * Improved Pro/Engineer Interface

    The converter for Pro/Engineer has been improved and brought up to
    date with Pro/Engineer 2001. Improvements include:

      o  Oriented and non-oriented triangle support.
      o  Unlimited-name-length support.

  * FASTGEN4 Name Extensions

    The FASTGEN4 converter fast4-g now supports names longer than 16
    characters.

  * Improved Hidden-Line Drawing Support

    A new program called rtedge is included for rendering hidden-line
    drawings through a raytracing technique.

  * Software Library for Multiply Referenced Objects

    A C implementation of the Tcl/Tk dual-ported object type is
    included.

  * New Shaders

    Two new shaders flat and invisible are included. The flat shader
    supports per-channel alpha blending.


NEW UTILITIES

pixcmp: This program Compares two pix format images. Although not
technically new (it was formerly included in source distributions),
pixcmp is now installed.

rtedge: This program raytraces models, detects edges, and writes
BRL-CAD color image (.pix) files.

g_diff: This program compares two geometry database files and reports
differences between the two. This allows databases that contain the
same objects in different orders to be recognized as being the same.

dbupgrade: This program upgrades an old BRL-CAD database to the
current BRL-CAD release file format. This allows older geometry to
take advantage of space savings and new functionality only available
with the newer database formats (e.g., convert a database created with
BRL-CAD rel4.5 to one that is fully functional in BRL-CAD rel6.0).


DEVELOPER NOTES

These items are of interest to developers and others who compile
BRL-CAD from a source code distribution:

  + Compile-time optimizations that significantly increase raytrace
    performance (at cost of run-time debugging).

  + Removed dependency on X (and Tk) during source compilation.

  + Consolidated cake build options.

  + MGED db developer command facilities.

  + New and improved regression test suite.

  + Improved ANSI source conformance (still in transition).

  + New general-purpose Bourne-shell-based utility library (part of
    regression suite).  It includes support for file locking,
    semaphores, stdout/stderr/file logging, mail, cvs, packaging, and
    remote-host querying facilities.


DEPRECATED FEATURES

  lgt

    the lgt tool is replaced by the new rtedge tool.

  Redirection of I/O in g2asc and asc2g

    To support the new database file format, it was necessary to
    remove the ability to run g2asc and asc2g on streaming data.


SPECIAL ACKNOWLEDGMENT

This release is the last to introduce new features developed by Mike
Muuss. Mike embodied a unique blend of unparalleled intellect,
unquenchable curiosity, and unending enthusiasm to advance the
capabilities and performance of everything and everyone he touched. He
was the original architect of BRL-CAD and for 20 years guided its
development and emergence as one of the most advanced physically based
computer-aided design packages in the world. His presence and his
abilities will be missed.


----------------------------------------------------------------------
--- 2001-03-06  Release 5.3                                        ---
----------------------------------------------------------------------

A new maintenance release of BRL-CAD is now available.  The main
features are:

mged:
    - A dedication page has been added in memory of Mike Muuss
    - Solids are now referred to as Primitive Shapes or "prims" in
	much of the user interface
    - The 'make' command now properly distinguishes between "ell" and
      "ell1"
    - 'autoview' command added for resetting the view size and center
    to get all displayed objects on the display
    - Query ray now works when 'mged' is in perspective mode
    - Snap-to-grid now works in Matrix Edit mode
    - 'facetize' command now creates BOT primitives by default
    - User can now use 'edcodes' and 'red' to view data even if
    database is read-only
    - 'rt" command now has a default resolution of 512x512 instead of
      50x50
    - 'xpush' command now considers primitives outside the tree being
    pushed and will not create a duplicate of an existing unpushed
    primitive
    - "light" shader added to the shader selection GUI in the
    combination editor
    - Combination editor modified to warn user if he is about to
    overwrite an existing combination that has never been reconciled
    to the gui
    - Primitive (solid) and matrix selection listboxes now have
    horizontal scrollbars to enable users to see entire path
    - Menu item added to dump current 'mged' state into a users
    ".mgedrc" file
    - The overlap tool now plots the actual overlapping regions (to
    allow user to perform editing)
    - Upon quit, the overlap tool now restores display to its prior
      state
    - The overlap tool now accepts input from a file containing
    'g_lint' output
    - The default objects used by the overlap tool are now the
    currently displayed objects
    - The ray-trace control panel now has an "abort" button to stop
    currently running ray traces
    - The ray-trace control panel is now kept in sync with the
    relevant elements of the main menubar.
    - Now handles case of ray-traced image with size different from
    size of X window.
    - Added a description of the BOT primitive shape to the online
      manual

rt:
    - Ray-trace tolerance lowered to 0.0005 to produce more accurate
      images
    - Now honors the -R (do not report overlaps) option
    - Corrections to handling of some reflection/refraction rays in
    glass objects

rtg3:
    - Can now write a "ray_data" file containing ray origin and ray
    direction for each shotline.

nirt:
    - Now prints ALL overlaps it finds

poly-bot:
    - Added man page for poly-bot

fast4-g:
    - Corrected handling of WALL cards.
    - Added support for COMPSPLT
    - Added check for illegal second SECTION card for same component

g-vrml:
    - Light sources are now only converted once
    - Assigned colors are used even if no shader is applied
    - Eliminated emissive color for non-lights

nastran-g:
    - Default output is now BOT primitives.

g-iges:
    - Now handles newer primitives (height field, DSP, extrusion,
      CLINE, and BOT)

iges-g:
    - BOT primitives are now the default primitive for representing
      BREP objects

fbpoint:
    - Now works with mged X frame buffer

liboptical:
    - Corrected missing specular highlights

librt:
    - Corrected a bug in rt_boolweave() where fusing two hit points
    within tolerance gave incorrect results
    - Added a check to ensure that long shader strings are not
    truncated without the user being notified.
    - Added code to prevent spurious lines in the 'mged' display
    caused by a color change in the display list without a "move"
    command

CLINE primitive:
    - Added support for radius addition

PIPE primitive:
    - Added support for "db put", "db get" and "db adjust"


----------------------------------------------------------------------
--- 2000-08-21  Release 5.2                                        ---
----------------------------------------------------------------------

Bug fixes.


----------------------------------------------------------------------
--- 1999-09-15  Release 5.0                                        ---
----------------------------------------------------------------------

NEW FEATURES

* Modern graphical user interface (GUI)

* Integrated software development medium

* Controllability from other applications

* Dynamic geometry

* Dozens of new utilities (stand-alone programs)

* New application development libraries and reorganization of existing
  libraries

* HTML documentation

* Haar wavelet signal decomposition and reconstruction

* Barycentric combination

* Cascading and time estimation for animation

* projection shading


TCL/TK

Tcl is an embeddable, full-function interpreted command language.  Tk
is a toolkit, based on Tcl, for building user interfaces.  Tcl/Tk was
initially created by John Ousterhout.  The benefits include rapid
development, ease of providing applications a powerful scripting
language, and user convenience.  Tcl is an excellent "glue" language.
Using Tcl/Tk, a windowing shell interface to the BRL-CAD library
routines has been easily afforded.


MGED

The image frame buffer and ray trace rendering is now integrated into
MGED.  This supports disambiguous rendering, registration of geometry
with imported imagery, the ability to visually query individual rays,
and mouse-based edit and render support.  Additionally, MGED sports a
multiple view multipane mode for viewing the same geometry from
various views simultaneously.  Snap-to-grid support is added as is
networked collaboration.

There should now be uniform mouse-based manipulation of both geometry
and the MGED view.  There is a command history and support for
command-line editing.  There are GUI control panels for ray-traced
rendering, animation, color editing, snap-to-grid, angle/distance
cursor control, and setting material properties.


NEW UTILITIES

There is new conversion tools available now for converting BRL-CAD to
ACAD (General Dynamics) for XPATCH, Alias|Wavefront, Compaq (Digital
Equipment) OFF, and VRML.  Likewise, there are tools for converting
Cyberware digitization, NASTRAN, and 3D systems stereolithography
(stl) formats into BRL-CAD geometry.

Using the g_diff command, you can compare .g files and report
differences.  Non-manifold Geometry (NMGs) can be converted to more
simple primitives.  Finally, region ID support has been reorganized.

In the area of image tools, support for the Portable Network Graphics
(PNG) image format has been added.  This includes image conversion and
display.  Likewise, support for the YUV color model has been added.

Database Maintenance

* g_diff: Compare two BRL-CAD models, writing the results of the comparison
  as an mged(1) script to change one model into the other.
* nmg-polysolid: Convert all the NMG solids in a BRL-CAD model into polysolids.
* remapid: Perform batch modifications of region IDs in a BRL-CAD or TANKILL
  model.
* rtweight: Calculate weight, centroid, and volume data for a BRL-CAD model.
* texturescale: Scale a pix(5) stream to map onto a curved solid.

Converters

* cy-g: Convert from Cyberware digitizer output format to BRL-CAD.
* nastran-g: Convert from NASTRAN finite-element format to BRL-CAD.
* stl-g: Convert from 3D Systems stereolithography format to BRL-CAD.
* g-acad: Convert from BRL-CAD to the General Dynamics ACAD format.
* g-off: Convert from BRL-CAD to the DEC (Compaq) Object File Format.
* g-vrml: Convert from BRL-CAD to the Virtual Reality Markup Language
  format.
* g-wave: Convert from BRL-CAD to the Alias|Wavefront format.

Image Support Tools

* any-png.sh: Convert any of various image file formats to the PNG format.
* bw-png: Convert a bw(5) stream to the PNG format.
* fb-png: Save the contents of a frame buffer to a file in the PNG format.
* imgdims: Guess the width and height of an image file from the name of
  and/or number of bytes in the file.
* pixblend: Blend two pix(5) or bw(5) images either randomly or as a weighted
  average.
* pixborder: Add a 1-pixel-wide border to regions in a pix(5) stream of a
  specified color.
* pixclump: Quantize the colors in a pix(5) stream.
* pixcount: Sort the pixels in a pix(5) stream by color value.
* pixdsplit: Disentangle the chars from the doubles in a pixd(5) stream.
* pixmorph: Perform feature-based image metamorphosis between two pix(5)
  files.
* pixsubst: Change the pixels of a specified color in a pix(5) stream to a
  second specified color.
* pix-png: Convert a pix(5) stream to the PNG format.
* pix-yuv: Convert a pix(5) stream to YUV in CCIR-601 format.
* png_info: Display the non-image information found in a PNG stream.
* png-bw: Convert a PNG(5) stream to bw(5) format.
* png-fb: Display a PNG(5) stream on a frame buffer.
* png-pix: Convert a PNG(5) stream to pix(5) format.
* rtsil: Produce a hidden-line silhouette image.
* yuv-pix: Convert a stream in YUV (CCIR-601) format to pix(5) format.

Animation Tools

* anim_cascade: Evaluate movement of one object relative to another.
* anim_time: Estimate appropriate time parameters for a path.

Miscellaneous

* bary: Compute weighted sums (including barymetric combinations) of
  points.
* bwish: BRL-CAD version of wish(1), the Tcl/Tk-based windowing shell.
  Includes functionality of libbn(3), librt(3), etc.
* mst: Construct a minimum spanning tree for an input graph.
* wavelet: Perform Haar wavelet decomposition or reconstruction.


DEPRECATED FEATURES

As BRL-CAD continues to be developed and evolves, various application
programming interfaces (APIs), headers, and data types necessarily
change to fulfill development requirements and to not allow the APIs
to become overly complicated with unnecessary or undesired complexity.
As these changes are foreseen, features will be sometimes marked as
deprecated and will usually be made obsolete at some point in the
future.  For those situations, developers using the BRL-CAD libraries
may need to update to new API features in order to link with newer
versions of BRL-CAD.

See the CHANGES file for a transcript of features that are deprecated
or have already become obsolete.

---
See doc/history.txt for more historic information on BRL-CAD.  There
is contained information on releases that predate 1999 and the 5.0
release.  The entire history of the project is available through
Subversion revision control on Sourceforge.

NEWS items should be formatted to column 70 (default M-q in Emacs),
include credits to all significant contributors, and be descriptively
succinct.  NEWS items should be ONE LINE per user-visible change with
the description not exceeding column 70.  Multiple contributors may be
listed on the same or following line, separated by commas.  Items
should be written in plain English using the past tense or as a
verbless clause.

// Local Variables:
// mode: Text
// fill-column: 70
// End:
